<?php
/***************************************************
                admin/cats.php
               Written By: Yume
              Last Update: 6/14/07
            
 Allows for the editing and creation of categories.
 self invoking and edits categories table.
 
 This software is licensed under the GPL.
****************************************************/
include('header.php');

//need to include javascript files for the drag and drop.
echo "<script src='../lib/prototype.js' type='text/javascript'></script>\n";
echo "<script src='../lib/effects.js' type='text/javascript'></script>\n";
echo "<script src='../lib/dragdrop.js' type='text/javascript'></script>\n";
echo "<script src='../lib/controls.js' type='text/javascript'></script>\n";

function applyGetCatOrder($order, $id)
{
	//this function takes the list of order for all fields and the field to look for and gives the position in the array
	
	//order is a pipe delimited list of the order of categories.
	$order = substr($order,1);//first character is a pipe, get rid of it
	$myOrder = applyUnPipe($order);//turn it into an array. The old method of string parsing would choke on categories > 9.
	for ($i = 0; $i < count($myOrder); $i++)
	{
		if ($myOrder[$i] == $id)
		{
			return ($i+1);//first order is 1. not sure why.
		}
	}
	return 99;//shouldnt ever happen.
}

if (isset($_POST['cats'])) //if changes were submitted...
{
	if ($_POST['cats'] == "change") //if we're changing the order of fields...
	{
		$order = $_POST['theOrder']; //order is currently an encoded string....
		$order = ereg_replace("%[0-9a-fA-F]{2}", "", $order); //get rid of the random bullshit characters
		$order = str_replace("list", "|", $order); //pipe delimit it (currently delimited by the string 'list')
		
		echo "<div class='appFeedback'>\n";

		$findCats = applyQuery("SELECT * FROM `".$applyPrefix."categories`;");//maybe i should make a applyGetCats() function?
		while($mycat = applyRow($findCats)) //loop through all categories and update the db with the new order/name.
		{
			applyQuery("UPDATE `".$applyPrefix."categories` SET `catName` = '".$_POST['name'.$mycat['catID']]."', `catOrder` = '".applyGetCatOrder($order, $mycat['catID'])."', `catLoc` = '".$_POST['loc'.$mycat['catID']]."' WHERE `catID` = '".$mycat['catID']."';");
			if (isset($_POST['delete'.$mycat['catID']])) //check to see if the delete checkbox was checked..
			{
				if ($mycat['catID'] != 1)
				{
					applyDelCat($mycat['catID']);
				}
				else
				{
					echo "Can't delete that category.<br />\n";//can't delete the original category.
				}
			}
		}
		echo "The categories have been updated.<br />\n";
		echo "</div>\n";
	}
	elseif ($_POST['cats'] == "add") // if we're adding a new field....
	{
		//first, look up the highest order value for all categories.
		$applyTop = applySingleQuery("SELECT `catOrder` FROM `".$applyPrefix."categories` ORDER BY `catOrder` DESC LIMIT 1;");
		if (!$applyTop) $applyTop = 0;
		
		$applyTop++;//and add 1 to it so the new category is last in the list
		
		echo "<div class='appFeedback'>\n";
		applyMakeCat($_POST['catName'], "", $applyTop);//perform add.
		echo "</div>\n";
	}
}

function applyDisplayCat($cat)
{
	//This function takes a category and prints it out with an option to rename and delete.
	echo "<li id = 'theCat_".$cat['catID']."' class='appMove'>\n";
	echo "	<span><input type='text' size='32' value='".$cat['catName']."' name='name".$cat['catID']."'></span>\n";
	echo "	<span><select name='loc".$cat['catID']."'>";
	echo "		<option value='0' ";
	if ($cat['catLoc'] == 0) echo "selected";
	echo ">Left column</option>";
	echo "		<option value='1' ";
	if ($cat['catLoc'] == 1) echo "selected";
	echo ">Right column</option>";
	echo "</select></span>\n";
	echo "	<span>Delete? <input type='checkbox' name='delete".$cat['catID']."'></span>\n";
	echo "</li>\n";
}

echo "<div class='appSecHead'>Edit Categories</div>\n";
echo "<div class='appSecBody'>\n";

echo "<div id='list-info'>Click and drag categories to change order.</div>\n";

echo "<form method='post' name='appForm' action='cats.php' enctype='multipart/form-data'>\n";

$applyCats = applyGetCats();

echo "<ul id='list'>\n";

//loop through all categories and print them out.
for ($i = 0; $i < count($applyCats); $i++)
{
	applyDisplayCat($applyCats[$i]);
}

echo "</ul>\n";
echo "<input type='hidden' value='change' name='theOrder' id='theOrder'>\n";
echo "<input type='hidden' value='change' name='cats'>\n";
echo "<input type='submit' value='Save Changes' class='appBtn' onmouseover=\"this.className='appBtn appBtnHov'\" onmouseout=\"this.className='appBtn'\">\n";
echo "</form>\n";
?>
<!--This is javascript to update the form variable 'theOrder' each time an item is dragged. -->
<script type="text/javascript" src="../lib/engine.js"></script>       
<script type="text/javascript">
Sortable.create('list', {"onUpdate":function(){ $('theOrder').value = escape(Sortable.serialize('list')) } } );
</script>


<?php

echo "</div>\n";
echo "<div class='appSecFoot'></div>\n";

//print form for adding a new category
echo "<div class='appSecHead'>Add a Category</div>\n";
echo "<div class='appSecBody'>\n";
echo "<form method='post' name='appForm' action='cats.php' enctype='multipart/form-data'>\n";
echo "Name: <input type='text' size='32' name='catName'> \n";
echo "<input type='hidden' value='add' name='cats'>\n";
echo "<input type='submit' value='Add' class='appBtn' onmouseover=\"this.className='appBtn appBtnHov'\" onmouseout=\"this.className='appBtn'\">\n";
echo "</form>\n";
echo "</div>\n";
echo "<div class='appSecFoot'></div>\n";
include('footer.php');
?>