<?php
/***************************************************
                admin/diag.php
               Written By: Yume
              Last Update: 6/17/07
            
 Checks DB for consistancy. First only checks but
 you can fix problems if it finds any.
 
 $errors and $fixes store the number of errors/fixes
 encountered during the execution of the page.
 
 This software is licensed under the GPL.
****************************************************/
include('header.php');
echo "<div class='appSecHead'>Diagnostics - ";

$fix = 0;
if ($_GET['fix']=='yes')
{
	$fix = 1;
	echo "Performing fixes...";
}
else
{
	echo "Checking the database for consistancy...";
}

echo "</div>\n";
echo "<div class='appSecBody'>\n";

echo "<p>This page is a bandaid. Theoretically you shouldn't have to use it but it's for fixing database errors that crop up probably because of a bug. If you do have errors please report them so the real bugs can be squashed and problems can be stopped before - not after - they occur. Thanks.</p>\n";

$errors = 0;
$fixes = 0;
//Check fields table against columns in apps table.
echo "<div class='appMinHead'>Checking if all columns in apps table correspond to fields in fields table...</div><div class='appMinBody'><br />\n";

//first get all columns and fields into separate arrays
$allFields = applyGetAllFields(1);

$getColumns = applyQuery("SHOW COLUMNS FROM `".$applyPrefix."apps`;");
$allColumns = array();
while ($column = applyRow($getColumns))
{
	if ($column['Field'] != "appID")
	{
		array_push($allColumns, $column);
	}
}
applyFree($getColumns);

//then do the check/fix
for ($j = 0; $j < count($allColumns); $j++)
{
	$found = 0;
	for ($i = 0; $i < count($allFields); $i++)
	{
		//echo $allColumns[$j]['Field']." == "."app".$allFields[$i]['fieldID']."<br />\n";
		if ($allColumns[$j]['Field'] == "app".$allFields[$i]['fieldID'])
		{
			$found = 1;
		}
	}
	if (!$found)
	{
		if ($fix)
		{
			$fixes++;
			applyQuery("ALTER TABLE `".$applyPrefix."apps` DROP `".$allColumns[$j]['Field']."`;");
			echo "<div class='appFeedback'>The column ".$allColumns[$j]['Field']." has been removed from the apps table.</div>\n";
		}
		else
		{
			$errors++;
			echo "<div class='appWarning'>The entry for the column in apps '".$allColumns[$j]['Field']."' was not found in the fields table. Fixing this problem will remove this column.</div>\n";
		}
	}
}
echo "</div>\n";


//now do the same thing in reverse
echo "<div class='appMinHead'>Checking if all fields in fields table have a corresponding column in apps table...</div><div class='appMinBody'><br />\n";

//first get all columns and fields into separate arrays
$allFields = applyGetAllFields(1);

$getColumns = applyQuery("SHOW COLUMNS FROM `".$applyPrefix."apps`;");
$allColumns = array();
while ($column = applyRow($getColumns))
{
	if ($column['Field'] != "appID")
	{
		array_push($allColumns, $column);
	}
}
applyFree($getColumns);

//then do the check/fix
for ($j = 0; $j < count($allFields); $j++)
{
	$found = 0;
	for ($i = 0; $i < count($allColumns); $i++)
	{
		if ("app".$allFields[$j]['fieldID'] == $allColumns[$i]['Field'])
		{
			$found = 1;
		}
	}
	if (!$found)
	{
		if ($fix)
		{
			$fixes++;
			applyQuery("DELETE FROM `".$applyPrefix."fields` WHERE `fieldID` = '".$allFields[$j]['fieldID']."' LIMIT 1;");
			echo "<div class='appFeedback'>The field ".$allFields[$j]['fieldName']." has been removed.</div>\n";
		}
		else
		{
			$errors++;
			echo "<div class='appWarning'>The field in fields table '".$allFields[$j]['fieldName']."' was not found in the columns of the apps table. Fixing this problem will remove this field.</div>\n";
		}
	}
}
echo "</div>\n";


//check consistancy of # of comments given to an app.
echo "<div class='appMinHead'>Checking number of comments column against true number of comments...</div><div class='appMinBody'><br />\n";
$getApps = applyQuery("SELECT * FROM `".$applyPrefix."apps`;");
while ($app = applyRow($getApps)) //loop through all apps
{
	$findNumComms = applyQuery("SELECT count(*) FROM `".$applyPrefix."comments` WHERE `commAppID` = '".$app['appID']."';");
	$numComms = applyRow($findNumComms);
	applyFree($findNumComms);
	$num = $numComms[0];
	if ($num != $app['appNumComments'])
	{
		if ($fix)
		{
			$fixes++;
			applyQuery("UPDATE `".$applyPrefix."apps` SET `appNumComments` = '".$num."' WHERE `appID` = '".$app['appID']."';");
			echo "<div class='appFeedback'>The latest comment for the applicant ".$app['appName']." has been corrected.</div>\n";
		}
		else
		{
			$errors++;
			echo "<div class='appWarning'>The number of comments for the applicant ".$app['appName']." is incorrect.".$num."!=".$app['appNumComments']."</div>\n";
		}
		
	}
}
applyFree($getApps);
echo "</div>\n";


//check to see if latest comment for an app is properly reflected in the apps table.
echo "<div class='appMinHead'>Checking to see if latest comment is correct...</div><div class='appMinBody'><br />\n";
$getApps = applyQuery("SELECT * FROM `".$applyPrefix."apps`;");
while ($app = applyRow($getApps))//loop through all apps
{
	$findLastComm = applyQuery("SELECT * FROM `".$applyPrefix."comments` WHERE `commAppID` = '".$app['appID']."' ORDER BY `commTime` DESC LIMIT 1;");
	$lastComm = applyRow($findLastComm);
	applyFree($findLastComm);
	if ($app['appLastComment'] != 0 && $lastComm['commID'] != $app['appLastComment'])
	{
		if ($fix)
		{
			$fixes++;
			applyQuery("UPDATE `".$applyPrefix."apps` SET `appLastComment` = '".$lastComm['commID']."' WHERE `appID` = '".$app['appID']."';");
			echo "<div class='appFeedback'>The latest comment for the applicant ".$app['appName']." has been corrected.</div>\n";
		}
		else
		{
			$errors++;
			echo "<div class='appWarning'>The latest comment for the applicant ".$app['appName']." is incorrect.</div>\n";
		}
		
	}
}
applyFree($getApps);
echo "</div>\n";

//check to see if null comment exists/is in the right place.
//the null comment is the comment in the comments table with an ID of 0. It is necessary as the viewapps.php page performs a table join requiring it.
echo "<div class='appMinHead'>Checking to see if the null comment is correct...</div><div class='appMinBody'><br />\n";
$findNullComm = applyQuery("SELECT * FROM `".$applyPrefix."comments` WHERE `commID` = '0' LIMIT 1;");
$nullComm = applyRow($findNullComm);
if (!$nullComm['commTime'])//if you can't find the null comment...
{
	if ($fix)
	{
		$fixes++;
		applyMakeComment(0,0,"");
		$getNowLatestComment=applyQuery("SELECT `commID` FROM `".$applyPrefix."comments` WHERE `commAppID` = '0' ORDER BY `commTime` DESC LIMIT 1;");
		$nowLatestComment=applyRow($getNowLatestComment);
		$latestComment = $nowLatestComment[0];
		
		applyQuery("UPDATE `".$applyPrefix."comments` SET `commID` = '0' WHERE `commID` = '".$latestComment."' LIMIT 1 ;");
		echo "<div class='appFeedback'>The null comment has been recreated.</div>\n";
	}
	else
	{
		$errors++;
		echo "<div class='appWarning'>The null comment doesn't exist.</div>\n";
	}
}
applyFree($findNullComm);

echo "</div>\n";

//print out summary
echo "<div class='appMinHead'>Summary</div><div class='appMinBody'>\n";

if ($fix)
{
	echo "<div class='appFeedback'>Fixes complete. A total of ".$fixes." fixes were made.<br /><br /> Please <a href='diag.php'>check to see if the errors have gone away</a></div>\n";
}
else
{
	if (!$errors)
	{
		echo "<div class='appFeedback'>No errors were detected.</div>\n";
	}
	else
	{
		echo "<div class='appWarning'>A total of ".$errors." errors were detected.<br /><br /><a href='diag.php?fix=yes'>Fix the errors</a></div>\n";
	}
}
echo "</div>\n";
echo "</div>\n";
echo "<div class='appSecFoot'></div>\n";
include('footer.php');
?>