<?php
/***************************************************
              admin/fieldEdit.php
               Written By: Yume
              Last Update: 6/18/07
            
 provides a form for editing or adding a field, depending
 on the get['appID']. self-invoking.
 
 This software is licensed under the GPL.
****************************************************/
include('header.php');

if ($_POST['field'] == 'change')//if the form was submitted back to this page
{
	$applyRequired = 0;
	if (isset($_POST['fieldRequired']))
	{
		if ($_POST['fieldRequired'] == "on") $applyRequired	= 1;
	}
	if(isset($_GET['fieldID']))//if we're editing and not adding
	{
		//only can have one talent spec option because of the JS on the apply page. so check to see if one exists.
		$applyType = applySingleQuery("SELECT count(*) FROM `".$applyPrefix."fields` WHERE `fieldType` = '6' AND `fieldID` <> '".$_GET['fieldID']."';");
		if ($_POST['fieldType'] == 6 && $applyType)
		{
			echo "<div class='appWarning'>Field edit failed: You can't have more than one Talent Spec field.<br />\n";
			echo "<p><a href='fieldEdit.php'>Make a new field</a></p>\n";
			echo "<p><a href='fields.php'>Return to view all fields</a></p>\n";
			echo "</div>\n";
			include('footer.php');
			die();
		}
		//get old category to see if it's changing.
		$applyOldCat = applySingleQuery("SELECT `fieldCat` from `".$applyPrefix."fields` WHERE `fieldID` = '".$_GET['fieldID']."';");
		if ($_POST['fieldCat'] != $applyOldCat)//if the category is changing we'll need to assign a new field order. find largest from new category and add 1.
		{
			$applyTop = applySingleQuery("SELECT `fieldOrder` FROM `".$applyPrefix."fields` WHERE `fieldCat` = '".$_POST['fieldCat']."' ORDER BY `fieldOrder` DESC LIMIT 1;");
			if (!$applyTop) $applyTop = 0;
			$applyTop++;
		}
		else//grab the category's order since it isnt passed from the form.
		{
			
			$applyTop = applySingleQuery("SELECT `fieldOrder` from `".$applyPrefix."fields` WHERE `fieldID` = '".$_GET['fieldID']."';");
		}

		applyQuery("UPDATE `".$applyPrefix."fields` SET `fieldName` = '".$_POST['fieldName']."', `fieldCat` = '".$_POST['fieldCat']."', `fieldType`='".$_POST['fieldType']."', `fieldDesc` = '".$_POST['fieldDesc']."', `fieldDetails` = '".$_POST['fieldDetails']."', `fieldOrder` = '".$applyTop."', `fieldRequired` = '".$applyRequired."' WHERE `fieldID` = '".$_GET['fieldID']."';");
		applyQuery("ALTER TABLE `".$applyPrefix."apps` CHANGE `app".$_GET['fieldID']."` `app".$_GET['fieldID']."` ".applyTypeSQL($_POST['fieldType'], $_POST['fieldDetails']).";");
		echo "<div class='appFeedback'>\n";
		echo "The field <b>".$_POST['fieldName']."</b> has been updated.\n";
		echo "<p><a href='fieldEdit.php'>Make a new field</a></p>\n";
		echo "<p><a href='fields.php'>Return to view all fields</a></p>\n";
		echo "</div>\n";
	}
	else//if we're adding
	{
		//only can have one talent spec option because of the JS on the apply page. so check to see if one exists.
		$applyType = applySingleQuery("SELECT count(*) FROM `".$applyPrefix."fields` WHERE `fieldType` = '6';");
		if ($_POST['fieldType'] == 6 && $applyType)
		{
			echo "<div class='appWarning'>Field creation failed: You can't have more than one Talent Spec field.<br />\n";
			echo "<p><a href='fieldEdit.php'>Make a new field</a></p>\n";
			echo "<p><a href='fields.php'>Return to view all fields</a></p>\n";
			echo "</div>\n";
		}
		else
		{
			//need to determine what field order to give the new field. find the largest from the category it's in and ++
			$applyTop = applySingleQuery("SELECT `fieldOrder` FROM `".$applyPrefix."fields` WHERE `fieldCat` = '".$_POST['fieldCat']."' ORDER BY `fieldOrder` DESC LIMIT 1;");
			if (!$applyTop) $applyTop = 0;
			$applyTop++;
			
			//perform add and give feedback
			echo "<div class='appFeedback'>\n";
			applyMakeField($_POST['fieldName'], $_POST['fieldCat'], $_POST['fieldType'], $_POST['fieldDesc'], $_POST['fieldDetails'], $applyTop, $applyRequired);
			echo "<p><a href='fieldEdit.php'>Make a new field</a></p>\n";
			echo "<p><a href='fields.php'>Return to view all fields</a></p>\n";
			echo "</div>\n";
		}
	}
	include('footer.php');
	die();
}


if (isset($_GET['fieldID']))//if we're editing, grab the data for the field we're editing.
{
	$applyFindField = applyQuery("SELECT * FROM `".$applyPrefix."fields` WHERE `fieldID` = '".$_GET['fieldID']."';");
	$applyField = applyRow($applyFindField);
	applyFree($applyFindField);
}

if (isset($_GET['fieldID'])) echo "<div class='appSecHead'>Edit a Field</div>\n";
else echo "<div class='appSecHead'>Add a Field</div>\n";

echo "<div class='appSecBody'>\n";

//print out the form for making/editing a field.
if (isset($_GET['fieldID'])) echo "<form method='post' name='appForm' action='fieldEdit.php?fieldID=".$_GET['fieldID']."' enctype='multipart/form-data'>\n";
else echo "<form method='post' name='appForm' action='fieldEdit.php' enctype='multipart/form-data'>\n";
echo "<span class='appLeft'>Field Name:</span> <input type='text' size='32' name='fieldName' value='".$applyField['fieldName']."'><br />\n";
echo "<span class='appLeft'>Field Type:</span> <select name='fieldType' id='fieldType' onchange='javascript:updateDetails();'>\n";
for ($i = 1; $i < 7; $i++)
{
	echo "<option value='".$i."' ";
	if ($applyField['fieldType'] == $i) echo "selected ";
	echo ">".applyGetType($i)."</option>\n";//this function is in functions.php
}
echo "</select><br />\n";

//print out list of categories as options.
echo "<span class='appLeft'>Field Category:</span> <select name='fieldCat'>\n";

$applyCats = applyGetCats();

for ($i = 0; $i < count($applyCats); $i++)
{
	echo "<option value='".$applyCats[$i]['catID']."' ";
	if ($applyField['fieldCat'] == $applyCats[$i]['catID']) echo "selected ";
	echo ">".$applyCats[$i]['catName']."</option>\n";
}	
echo "</select><br />\n";

//generate javascript function to describe what the details field does for a given type.
?>
<script type='text/javascript'>
function updateDetails(type)
{
	var getType = document.getElementById("fieldType");
	type = getType.value;
	
	var elementName = "detailsField";
	var myVar = document.getElementById(elementName);
	var details = "";
<?php
for ($i = 1; $i < 7; $i++)
{
	echo "	if (type == ".$i.") details += \"".applyGetTypeDetails($i)."\";\n";
}
?>	
	myVar.innerHTML = details;
}
</script>
<?php


if (isset($applyField['fieldType'])) $detailsField = applyGetTypeDetails($applyField['fieldType']);
else $detailsField = applyGetTypeDetails(1);

echo "<span class='appLeft'>Field Description:</span> <input type='text' size='64' name='fieldDesc' value='".$applyField['fieldDesc']."'><br />\n";
echo "<span class='appLeft'>Field Details:</span> <input type='text' size='64' name='fieldDetails' value='".$applyField['fieldDetails']."'>\n";
echo "<i><span id='detailsField'>".$detailsField."</div></i>\n";

echo "<input type='checkbox' name='fieldRequired'";
if ($applyField['fieldRequired']) echo " checked";
echo "> Make this field required?<br />\n";


echo "<input type='hidden' value='change' name='field'>\n";
echo "<input type='submit' value='Submit' class='appBtn' onmouseover=\"this.className='appBtn appBtnHov'\" onmouseout=\"this.className='appBtn'\">\n";
echo "</form>\n";

echo "</div>\n";
echo "<div class='appSecFoot'></div>\n";

include('footer.php');
?>