<?php
/***************************************************
               admin/fields.php
               Written By: Yume
              Last Update: 6/14/07
            
 Allows for the changing of order and deletion of fields.
 self-invoking. 
 
 also provides links to fieldEdit.php for editing fields
 and adding new fields.
 
 This software is licensed under the GPL.
****************************************************/
include('header.php');

echo "<div class='appSecHead'>Edit Fields</div>\n";
echo "<div class='appSecBody'>\n";
if ($_POST['fields'] == "change")//if the form was submitted back to here...
{
	echo "<div class='appFeedback'>\n";
	$applyFields = applyGetAllFields();
	for ($i = 0; $i < count($applyFields); $i++)//check for deletions... loop through all fields and look for one with delete checkbox checked.
	{
		if ($_POST['delete'.$applyFields[$i]['fieldID']] == 'on')
		{
			applyDelField($applyFields[$i]['fieldID']);
		}
	}
	$applyFields = applyGetAllFields(); //get fields again in case we deleted some.
	for ($i = 0; $i < count($applyFields); $i++)//loop through all fields to update field order.
	{
		//$applyTop stores the order that we're going to set the field to so we can perform checks and modify it if necessary.
		
		//make sure that we're not trying to set the order of the field to be a value that already exists.
		$myCat = $applyFields[$i]['fieldCat'];
		$findExisting = applyQuery("SELECT * FROM `".$applyPrefix."fields` WHERE `fieldOrder` = '".$_POST['order'.$applyFields[$i]['fieldID']]."' AND `fieldCat` = '".$myCat."';");
		if ($existing = applyRow($findExisting))//does php autoreject AND conditionals if the first one isn't true? then i could collapse the two elses below....
		{
			if ($existing['fieldID'] != $applyFields[$i]['fieldID'])//if the value already exists and it isn't itself then we have to reset the value to be something else.
			//this'll probably choke if you try and swap the order of two fields?
			{
				$applyTop = applySingleQuery("SELECT `fieldOrder` FROM `".$applyPrefix."fields` WHERE `fieldCat` = '".$myCat."' ORDER BY `fieldOrder` DESC LIMIT 1;");
				if (!$applyTop) $applyTop = 0;
				$applyTop++;
				echo "Warning! Duplicate order was attempted for field <b>".$applyFields[$i]['fieldName']."</b>. This field has been moved to the end of the category.<br />\n";
			}
			else
			{
				$applyTop = $_POST['order'.$applyFields[$i]['fieldID']];
			}
		}
		else
		{
			$applyTop = $_POST['order'.$applyFields[$i]['fieldID']];
		}
		applyFree($findExisting);
		applyQuery("UPDATE `".$applyPrefix."fields` SET `fieldOrder` = '".$applyTop."' WHERE `fieldID` = '".$applyFields[$i]['fieldID']."';");
	}
	echo "<p>The order of fields has been updated.</p>\n";
	echo "</div>\n";
}

////////////////////////////////// Functions ////////////////////////////////////////////

function applyDisplayField($field)
{
	//prints out a table row for a fields, including an option for editing and deleting it.
	echo "<tr>\n";
	echo "	<td><a href='fieldEdit.php?fieldID=".$field['fieldID']."'>".$field['fieldName']."</a></td>\n";
	echo "	<td>".applyGetType($field['fieldType'])."</td>\n";
	echo "	<td><input type='checkbox' name='delete".$field['fieldID']."'></td>\n";
	echo "	<td><input type='text' size='2' value='".$field['fieldOrder']."' name='order".$field['fieldID']."'></td>\n";
	echo "</tr>\n";
}
////////////////////////////////// End Functions ///////////////////////////////////
echo "<p><a href='fieldEdit.php'>Add a new Field</a></p>\n";
echo "<form method='post' name='appForm' action='fields.php' enctype='multipart/form-data'>\n";

//print out all fields in order.
$applyCats = applyGetCats();
for ($i = 0; $i < count($applyCats); $i++)
{
	$myCat = $applyCats[$i];
	echo "<div class='appMinHead'>".$myCat['catName']."</div>\n";
	echo "<div class='appMinBody'>\n";
	echo "<table border='0' cellpadding='3' cellspacing='0'>\n";
	echo "<tr><td class='appHead'>Name</td><td class='appHead'>Type</td><td class='appHead'>Delete</td><td class='appHead'>Order</td></tr>\n";
	$fields = applyQuery("SELECT * FROM `".$applyPrefix."fields` WHERE `fieldCat` = '".$myCat['catID']."';");
	$myFields = array();
	while ($field = applyRow($fields)) $myFields[$field['fieldOrder']] = $field;
	applyFree($fields);
		
	$myFieldsSorted = array();
	$fieldKeys = array_keys($myFields);
	sort($fieldKeys);
	for ($j = 0; $j < count($fieldKeys); $j++)
	{
		array_push($myFieldsSorted, $myFields[$fieldKeys[$j]]);
	}
	for ($j = 0; $j < count($myFieldsSorted); $j++)
	{
		applyDisplayField($myFieldsSorted[$j]);
	}
	echo "</table>\n";
	echo "</div>\n";
}
echo "<input type='hidden' value='change' name='fields'>\n";
echo "<input type='submit' value='Save Changes' class='appBtn' onmouseover=\"this.className='appBtn appBtnHov'\" onmouseout=\"this.className='appBtn'\">\n";
echo "</form>\n";

echo "</div>\n";
echo "<div class='appSecFoot'></div>\n";

include('footer.php');
?>