<?php
/***************************************************
				   apply.php
			   Written By: Yume
			  Last Update: 6/19/07
			
 This page displays the main form for the application.
 The page is self-invoking and when invoked it puts
 data into the _apps table.
   
 This software is licensed under the GPL.
****************************************************/

include("header.php");

applyRequireLoggedIn();

$theDate = time();
$applyCats = applyGetCats();
$applyCompletedSteps = array();
$applyFailedFields = array();
$applyFailedCount = 0;
$incomplete = -1;

$applyEdit = 0;
if ($_GET['appID']) //Edit function - prepopulates form with all previously entered data.
{
	$applyEdit = $_GET['appID'];
	$applyGetApp = applyQuery("SELECT * FROM `".$applyPrefix."apps` WHERE `appID` = '".$_GET['appID']."';");
	$applyForm = applyRow($applyGetApp);
	applyFree($applyGetApp);
	if ($applyForm['appUserName'] != $applyUserdata['userName']) die("hacking attempt");//This will flag if someone tries to edit an application that doesn't belong to them.
}

//look to see if form was submitted back to here, and what button was pushed
$postKeys = array_keys($_POST);
for ($i = 0; $i < count($_POST); $i++)
{
	if (substr($postKeys[$i],0,5) == "submt")
	{
		$applyFormPage = (int)substr($postKeys[$i],5);
	}
}

if (isset($_POST['completedSteps']))
{
	$applyCompletedSteps = applyUnpipe($_POST['completedSteps']);
	array_push($applyCompletedSteps, $_POST['multiCat']);
}

if (isset($_POST["appEdit"]))
{
	if ($_POST['appEdit'] > 0) 	$applyEdit = $_POST['appEdit'];

	//if the form was submitted back to this page
	//We're going to make an array of what's going to be put into the DB.
	//First, grab all fields.
	$applyFields = applyGetAllFields();

	//Now all fields that came through the form are in applyFields.
	$applyForm = array(); //keys will be the column name in _apps table... value is the data.
	$applyForm['appUpdated'] = $theDate;
	
	if ($applyEdit) array_push($applyFields, array("fieldID" => "EditUpdate", "fieldName" => "Edit Changes", "fieldCat" => $applyCats[count($applyCats)-1]["catID"], "fieldRequired" => 1, "fieldType" => 2));
	
	for ($i = 0; $i < count($applyFields); $i++)
	{
		$applyKey = "app".$applyFields[$i]['fieldID'];
		$applyValue = "";
		
		$applyType = $applyFields[$i]['fieldType'];
		if($applyType == 1) $applyValue = $_POST[$applyKey];
		if($applyType == 2) $applyValue = $_POST[$applyKey];
		if($applyType == 3) $applyValue = $_POST[$applyKey];
		if($applyType == 4) $applyValue = applyCheckboxEncode($_POST[$applyKey]);
		if($applyType == 5) $applyValue = applyAvailabilityEncode($_POST, $applyFields[$i]['fieldID']);
		if($applyType == 6) $applyValue = applyTalentEncode($_POST, $applyFields[$i]['fieldID']);
		$applyForm[$applyKey] = applyNoQuote($applyValue);
		
		if ($applyFields[$i]["fieldRequired"] == 1 && isset($_POST[$applyKey]) && in_array($applyFields[$i]['fieldCat'], $applyCompletedSteps))
		{
			if (!applyCheckRequiredField($applyFields[$i], $_POST[$applyKey]))
			{
				array_push($applyFailedFields, $applyFields[$i]);
				$applyFailedCount++;
			}
		}
	}
	
	if ($applyFailedCount)
	{
		for ($i = 0; $i < count($applyFailedFields); $i++)
		{
			for ($j = 0; $j < count($applyCompletedSteps); $j++)
			{
				if($applyFailedFields[$i]["fieldID"] == $applyCompletedSteps[$j])
				{
					$array_temp  = array_slice($applyCompletedSteps, 0, $j );
					$array_temp2 = array_slice($applyCompletedSteps, $j+1, count($applyCompletedSteps)-1 );
					$applyCompletedSteps = array_merge($array_temp, $array_temp2);	
				}
			}
			
		}
	}
}

if ($applyFailedCount)
{
	echo "<div class='appWarning'>\n";
	echo "<p>The following required field";
	if ($applyFailedCount > 1) echo "s were";
	else echo " was";
	echo " not filled out: ";
	for ($i = 0; $i < $applyFailedCount; $i ++)
	{
		if ($i > 0) echo ", ";
		echo $applyFailedFields[$i]["fieldName"];	
	}
	echo "</p>\n";
	echo "</div>\n";
}


if ($_POST["submt0"] == "Submit Application" && !$applyFailedCount)// if it's a final submission.
{
	if ($_POST['isMulti']) $incomplete = applyFindIncomplete($applyCompletedSteps, $applyCats);

	if ($incomplete == -1)
	{
		$applyForm = applyRemoveEditField($applyForm);
		if ($_POST['appEdit'] > 0) //if they were editing their app, update the DB as opposed to adding a new row.
		{
			$applyGetApp = applyQuery("SELECT * FROM `".$applyPrefix."apps` WHERE `appID` = '".$_POST['appEdit']."';");
			$applyMyApp = applyRow($applyGetApp);
			applyFree($applyGetApp);
			
			if ($applyUserdata['userName'] != $applyMyApp['appUserName']) die('hacking attempt');//Someone was trying to edit an app that wasn't theirs.
			$applyUpdate = "UPDATE `".$applyPrefix."apps` SET ";
			
			$applyKeys = array_keys($applyForm);
			$applyValues = array_values($applyForm);

			for ($i = 0; $i < count($applyKeys); $i++)
			{
				if ($i > 0) $applyUpdate .= ", ";
				$applyUpdate .= "`".$applyKeys[$i]."` = \"".$applyValues[$i]."\"";
			}
			$applyUpdate .= "WHERE `appID` = '".applyNoQuote($_POST['appEdit'])."';";

			applyQuery($applyUpdate);
			applyQuery("INSERT INTO `".$applyPrefix."edits` (`editAppID`, `editTime`, `editDescription`) VALUES ('".$_POST['appEdit']."', '".$theDate."', \"".applyNoQuote($_POST['appEditUpdate'])."\");");
			
			echo "<div class = 'appSecHead'>" . applyTitle("Application Edit Successful") . "</div>\n";
			echo "<div class = 'appSecBody'>\n";
			echo "<p>Thank you for your interest in ".$applyConfig['guildName'].". We will review your application and contact you in-game if we are interested.</p>";
			echo "<p><a href = 'view.php'>View/Edit your Application</a></p>";
		}
		else //if a brand new application was submitted.
		{
			$applyDoesUserExist = applyQuery("SELECT * FROM `".$applyPrefix."apps` WHERE `appName` = '".$_POST['appName']."';");
			if ($applyUser = applyRow($applyDoesUserExist)) //Check to make sure a user isn't creating an application for a name that already exists
			{
			echo "<div class = 'appSecHead'>" . applyTitle("ApplicationFailed") . "</div>\n";
			echo "<div class = 'appSecBody'>\n";
				echo "<p>An application has already been put in for a person with the name " . $_POST['appName'] . ". Please contact an officer or administrator on the forums or in-game for assistance.</p>\n<p>If you were attempting to edit or update your application, please visit the <a href = 'view.php'>View/Edit my application</a> page. Applications are tied to your forum login name so you must go to the forums and login if you have not yet done so.</p>\n";
			}
			else //passes all checks, go ahead and insert into DB
			{
				$applyForm['appCreated'] = $theDate;
				$applyForm['appUpdated'] = $theDate;
				$applyForm['appUserName'] = $applyUserdata['userName'];
				$applyForm['appUserEmail'] = $applyUserdata['userEmail'];
				$applyForm['appNumComments'] = "0";
				$applyForm['appLastComment'] = "0";
				$applyForm['appStatus'] = "0";
				//Generate the sql statement
				$applyInsert = "INSERT INTO `".$applyPrefix."apps` (";
				$applyKeys = array_keys($applyForm);
				for ($i = 0; $i < count($applyKeys); $i++)
				{
					if ($i > 0) $applyInsert .= ", ";
					$applyInsert .= $applyKeys[$i];
				}
				$applyInsert .= ") VALUES (";
				$applyValues = array_values($applyForm);
				for ($i = 0; $i < count($applyValues); $i++)
				{
					if ($i > 0) $applyInsert .= ", ";
					$applyInsert .= "\"".$applyValues[$i]."\"";
				}
				$applyInsert .= ");";
				applyQuery($applyInsert);
				
				echo "<div class = 'appSecHead'>" . applyTitle("Application Successful") . "</div>\n";
				echo "<div class = 'appSecBody'>\n";
				echo "<p>Thank you for your application to ".$applyConfig['guildName'].". We will review your application and contact you in-game if we are interested.</p>";
				echo "<p><a href = 'view.php'>View/Edit your Application</a></p>";
			}
			applyFree($applyDoesUserExist);
		}
		echo "</div>\n";//end appSecBody
		echo "<div class='appSecFoot'></div>\n";
		include("footer.php");
		die();
	}
}

/////////////////////////////// Functions ////////////////////////////////////////

function applyRemoveEditField($applyForm)
{
	$keys = array_keys($applyForm);
	for ($j = 0; $j < count($applyForm); $j++)
	{
		if($keys[$j] =="appEditUpdate")
		{
			$array_temp  = array_slice($applyForm, 0, $j );
			$array_temp2 = array_slice($applyForm, $j+1, count($applyForm)-1 );
			$applyForm = array_merge($array_temp, $array_temp2);	
		}
	}
	return $applyForm;
}

function applyCheckRequiredField($field, $data)
{
	$type = $field["fieldType"];
	//checks a single field to see if it was filled out.
	if ($type == 1)//single line text
	{
		if ($data != "") return 1;
	}
	if ($type == 2)//large input box
	{
		if ($data != "") return 1;
	}
	if ($type == 3)//dropdown
	{
		if ($data != "") return 1;
	}
	if ($type == 4) //checkbox
	{
		return 1;
	}
	if ($type == 5) //availability
	{
		if (count(applyUnpipe($data)) == 14) return 1;
	}
	if ($type == 6) //spec
	{
		if (count(applyUnpipe($data)) == 6) return 1;
	}
	
	return 0;	
}

function applyFindIncomplete($steps, $cats)
{
	for ($i = 0; $i < count($cats); $i++)
	{
		if (!in_array($cats[$i]["catID"], $steps))
		{
			return $i;
		}
	}
	return -1;
}

function applyAvailabilityEncode($post, $id)
{
	//Takes the whole post and the ID and fetches out the availability data, and returns a pipe delimited string of the data.
	$arr = array();
	//too lazy to write a loop
	if (isset($post['app'.$id."_00"]))
	{
		array_push($arr, $post['app'.$id."_00"]);
		array_push($arr, $post['app'.$id."_01"]);
		array_push($arr, $post['app'.$id."_10"]);
		array_push($arr, $post['app'.$id."_11"]);
		array_push($arr, $post['app'.$id."_20"]);
		array_push($arr, $post['app'.$id."_21"]);
		array_push($arr, $post['app'.$id."_30"]);
		array_push($arr, $post['app'.$id."_31"]);
		array_push($arr, $post['app'.$id."_40"]);
		array_push($arr, $post['app'.$id."_41"]);
		array_push($arr, $post['app'.$id."_50"]);
		array_push($arr, $post['app'.$id."_51"]);
		array_push($arr, $post['app'.$id."_60"]);
		array_push($arr, $post['app'.$id."_61"]);
		return applyPipe($arr);
	}
	return $post['app'.$id];
	
}

function applyCheckboxEncode($item)
{
	return $item;
}
function applyTalentEncode($post, $id)
{
	//Takes the whole post and the ID and fetches out the talent data, and returns a pipe delimited string of the data.
	$arr = array();
	if (isset($post['app'.$id."_10"]))
	{
		array_push($arr, $post['app'.$id."_10"]);
		array_push($arr, $post['app'.$id."_11"]);
		array_push($arr, $post['app'.$id."_20"]);
		array_push($arr, $post['app'.$id."_21"]);
		array_push($arr, $post['app'.$id."_30"]);
		array_push($arr, $post['app'.$id."_31"]);
		return applyPipe($arr);
	}
	return $post['app'.$id];
}

function applyDisplayForm($field)
{
	//Takes a field table row and passes it along to the proper function
	if ($field['fieldType'] == 1) applyDisplayForm1($field);
	if ($field['fieldType'] == 2) applyDisplayForm2($field);
	if ($field['fieldType'] == 3) applyDisplayForm3($field);
	if ($field['fieldType'] == 4) applyDisplayForm4($field);
	if ($field['fieldType'] == 5) applyDisplayForm5($field);
	if ($field['fieldType'] == 6) applyDisplayForm6($field);
}

function applyDisplayForm1($field)
{
	global $applyForm;
	//displays a single line input box
	echo "<p";
	if ($field['fieldRequired']) echo " class='appRequired'";
	echo ">".$field['fieldName'].":<br /><input type='text' name='app".$field['fieldID']."' value=\"".$applyForm['app'.$field['fieldID']]."\" size='".$field['fieldDetails']."' /></p>\n";
}

function applyDisplayForm2($field)
{
	global $applyForm;
	//displays a large input box.
	echo "<p";
	if ($field['fieldRequired']) echo " class='appRequired'";
	echo ">".$field['fieldName']."<br />\n";
	echo (!empty($field['fieldDesc'])) ? "<i>".$field['fieldDesc']."</i><br />\n" : ''; 
	echo "<textarea name='app".$field['fieldID']."' cols='80' rows = '6'>".$applyForm['app'.$field['fieldID']]."</textarea></p>\n";
}

function applyDisplayForm3($field)
{
	global $applyForm;
	//displays a dropdown.
	$arr = applyUnPipe($field['fieldDetails']);
	echo "<p";
	if ($field['fieldRequired']) echo " class='appRequired'";
	echo ">".$field['fieldName'].":<br />\n";
	echo "<select name='app".$field['fieldID']."' ";
	if ($field['fieldID'] == "Class") echo "onchange='populateTalent()' ";
	echo ">\n";
	if ($field['fieldID'] == "Class") echo "		<option value=''>-- Select Class --</option>\n";
	for ($i = 0; $i < count($arr); $i++)
	{
		echo "		<option ";
		if($applyForm['app'.$field['fieldID']] == $arr[$i]) echo "selected ";
		echo "value=\"".$arr[$i]."\">".$arr[$i]."</option>\n";
	}
	echo "	</select>\n</p>\n";
}

function applyDisplayForm4($field)
{
	global $applyForm;
	//displays a checkbox.
	echo "<p";
	if ($field['fieldRequired']) echo " class='appRequired'";
	echo ">".$field['fieldName'].":<input name='app".$field['fieldID']."' type='checkbox' ";
	if($applyForm['app'.$field['fieldID']] == "on") echo "checked ";
	if(strtolower($field['fieldDetails']) == "disabled") echo "disabled='disabled' ";
	echo " />";
	if ($field['fieldDesc']) echo "<i>".$field['fieldDesc']."</i>";
	echo "</p>\n";
}

function applyDisplayForm5($field)
{
	global $applyForm;
	//displays a method for inputting your availability. right now it's dropdowns but down the line it'd be nice to make a graphical interface
	
	echo "<script type='text/javascript'>\n";
	echo "function updateCal".$field['fieldID']."(day)\n";
	echo "{\n";
	echo "	var elementName = \"cal".$field['fieldID']."_\"+day;\n";
	echo "	var myVar = document.getElementById(elementName);\n";
	echo "	var dayBeg = document.getElementById('app".$field['fieldID']."_'+day+'0');\n";
	echo "	var dayEnd = document.getElementById('app".$field['fieldID']."_'+day+'1');\n";
	echo "	var hours = parseInt(dayEnd.value)- parseInt(dayBeg.value);\n";
	echo "	myVar.innerHTML = hours;\n";
	echo "}\n";
	echo "</script>\n";
	
	$days = array("Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday", "Sunday");
	
	$startStop = applyUnPipe($applyForm['app'.$field['fieldID']]);
	$tick = 0;
	if ($field['fieldRequired']) echo "<div class='appRequired'>\n";
	for ($i = 0; $i < count($days); $i++)
	{
		echo "<p>\n";
		echo "	".$days[$i].": From \n";
		echo "	<select name='app".$field['fieldID']."_".$i."0' id='app".$field['fieldID']."_".$i."0' onchange='javascript:updateCal".$field['fieldID']."(".$i.");'>\n";
		for ($time = 1; $time <= 12; $time++)
		{
			echo "		<option value='".$time."' ";
			if ($time == $startStop[$tick]) echo "selected ";
			echo ">".$time.":00 ";
			if ($time < 12) echo "pm";
			else echo "am";
			echo "</option>\n";
		}
		echo "	</select>\n";
		$tick++;
		echo "	 until \n";
		echo "	<select name='app".$field['fieldID']."_".$i."1' id='app".$field['fieldID']."_".$i."1' onchange='javascript:updateCal".$field['fieldID']."(".$i.");'>\n";
		for ($time = 1; $time <= 12; $time++)
		{
			echo "		<option value='".$time."' ";
			if ($time == $startStop[$tick]) echo "selected ";
			echo ">".$time.":00 ";
			if ($time < 12) echo "pm";
			else echo "am";
			echo "</option>\n";
		}
		echo "	</select>\n";		
		$tick++;
		echo "	<i>(Available <span id='cal".$field['fieldID']."_".$i."'>";
		$numHours = $startStop[$tick-1] - $startStop[$tick-2];
		if ($numHours < 0) $numHours = 0;
		echo $numHours;
		echo "</span> hours)</i>\n";
		echo "</p>\n";
	}
	if ($field['fieldRequired']) echo "</div>\n";
	
}

function applyDisplayForm6($field)
{
	global $applyForm, $_POST, $applyClasses;
	//Displays entry fields for entering your talent spec.
	
	applyGenClassJS();//generate javascript thingy for classes.
	
	$specStr = $applyForm['app'.$field['fieldID']];
	
	if ($specStr == "|||||" || (!$specStr && $applyForm['appClass']))
	{
		$specStr = "|".$applyClasses[$applyForm['appClass']][0]."||".$applyClasses[$applyForm['appClass']][1]."||".$applyClasses[$applyForm['appClass']][2];
	}

	$mySpec = applyUnPipe($specStr);
	
	$tick = 0;
	if ($_POST['appClass']) $exampleClass= $_POST['appClass'];
	else 
	{
		$exampleClass = applyUnpipe(applyGetClasses());
		$exampleClass = $exampleClass[0];
	}
	
	echo "<p";
	if ($field['fieldRequired']) echo " class='appRequired'";
	echo ">\n";
	echo "	".$field['fieldName']."<br />\n";
	for ($i = 1; $i < count($applyClasses[$exampleClass])+1; $i++)
	{
		echo "		<input type='text' name='app".$field['fieldID']."_".$i."0' value='".$mySpec[$tick]."' size='4' />\n";
		$tick++;
		echo "		 points in \n";
		echo "		<input type='text' name='app".$field['fieldID']."_".$i."1' id = 'appSpec".$i."' value=\"".$mySpec[$tick]."\" size='15' />\n";
		$tick++;
		echo "		<br />\n";
	}
	echo "</p>\n";
}

function applyCatIndex($catID)
{
	global $applyCats;
	//This function returns the index in applycats where catID is.
	
	for ($i = 0; $i < count($applyCats); $i++)
	{
		if ((int)$applyCats[$i]["catID"] == (int)$catID) return $i;
	}
	return 0;
}

function applyPrintHiddenFields($myCat)
{
	//prints out a category as hidden fields.
	global $applyPrefix, $applyForm, $applyCats;

	$fields = applyQuery("SELECT * FROM `".$applyPrefix."fields` WHERE `fieldCat` = '".$myCat['catID']."';");
	$myFields = array();
	while ($field = applyRow($fields)) $myFields[$field['fieldOrder']] = $field;
	applyFree($fields);
	
	$myFieldsSorted = array();
	if ($myCat['catID'] == 1) //if we're doing General Info, add in necessary fields
	{
		$myFieldsSorted = applyFieldsPopulate($myFieldsSorted);
	}
	$fieldKeys = array_keys($myFields);
	sort($fieldKeys);
	for ($j = 0; $j < count($fieldKeys); $j++)
	{
		array_push($myFieldsSorted, $myFields[$fieldKeys[$j]]);
	}
	if ($myCat == $applyCats[count($applyCats)-1])
	{
		array_push($myFieldsSorted, array("fieldID" => "EditUpdate", "fieldName" => "Edit Changes", "fieldCat" => $applyCats[count($applyCats)-1]["catID"], "fieldRequired" => 1, "fieldType" => 2));
	}

	for ($j = 0; $j < count($myFieldsSorted); $j++)
	{
		if (isset($applyForm["app".$myFieldsSorted[$j]["fieldID"]]))
		{
			echo "<input type='hidden' name=\""."app".$myFieldsSorted[$j]["fieldID"]."\" value=\"".$applyForm["app".$myFieldsSorted[$j]["fieldID"]]."\" />\n";
		}
	}
}
////////////////////////////// End Functions ////////////////////////////////////

echo "<script src='lib/apply.js' type='text/javascript'></script>\n";

if ($applyEdit)	echo "<div class = 'appSecHead'>".applyTitle("Edit your Application")."</div>\n";
else echo "<div class = 'appSecHead'>".applyTitle("Make an Application")."</div>\n";
echo "<div class = 'appSecBody'>\n";
echo "<form method='post' id='appform' action='apply.php' enctype='multipart/form-data' style='margin:0; padding:0;'>\n";

$catFilter = "";
if ($applyConfig['multiStep'] == 1)
{
	if (!$applyFailedCount)
	{
		if ($incomplete == -1)
		{
			$catFilter = "WHERE `catID` = ";
			if ($_POST['isMulti'] == 1)
			{
				$catToPrint = $applyFormPage;
			}
			else
			{	
				$catToPrint = $applyCats[0]["catID"];
			}
			$catIndex = applyCatIndex($catToPrint);
		}
		else
		{
			$catIndex = $incomplete;
		}
	}
	else
	{
		$catID = $applyFailedFields[0]["fieldCat"];
		$catIndex = applyCatIndex($catID, $applyCats);
	}
	$catsToPrint = array($applyCats[$catIndex]);
}
else
{
	$catsToPrint = $applyCats;
}

if (isset($_POST['appEdit']))
{
	
	$applyForm = $applyForm;
}

$counter = 1;
for ($i = 0; $i < count($catsToPrint); $i++)
{
	$myCat = $catsToPrint[$i];
	echo "<div class='appMinHead'>".$myCat['catName']."</div>\n";
	echo "<div class='appMinBody'>";
	$fields = applyQuery("SELECT * FROM `".$applyPrefix."fields` WHERE `fieldCat` = '".$myCat['catID']."';");
	$myFields = array();
	while ($field = applyRow($fields)) $myFields[$field['fieldOrder']] = $field;
	applyFree($fields);
	
	$myFieldsSorted = array();
	if ($myCat['catID'] == 1) //if we're doing General Info, add in necessary fields
	{
		$myFieldsSorted = applyFieldsPopulate($myFieldsSorted);
	}
	$fieldKeys = array_keys($myFields);
	sort($fieldKeys);
	for ($j = 0; $j < count($fieldKeys); $j++)
	{
		array_push($myFieldsSorted, $myFields[$fieldKeys[$j]]);
	}
	for ($j = 0; $j < count($myFieldsSorted); $j++)
	{
		echo "<div ";
		if ($myFieldSorted[$j]["fieldRequired"] == 1) echo "class='appRequired'";
		echo ">\n";
		applyDisplayForm($myFieldsSorted[$j]);
		echo "</div>\n";
	}
	echo "</div>\n"; //end appminbody
	$counter++;
}

if ($applyConfig['multiStep'] == 1)//if we're multistep, print out hidden fields containing data already submitted.
{									//Everything is stored client-side till its completely done.
	if ($_POST['isMulti'] == 1)
	{
		for ($i = 0; $i < count($applyCats); $i++)
		{
			$myCat = $applyCats[$i];
			if (!in_array($myCat, $catsToPrint))
			{
				applyPrintHiddenFields($myCat);
			}
		}
	}
	else
	{
		if ($applyEdit)
		{
			for ($i = 0; $i < count($applyCats); $i++)
			{
				$myCat = $applyCats[$i];
				if (!in_array($myCat, $catsToPrint))
				{
					$applyForm = $applyForm;
					applyPrintHiddenFields($myCat);
				}
			}
		}
	}
	echo "<input type='hidden' name='isMulti' value='1'/>\n";
	echo "<input type='hidden' name='multiCat' value='".$catsToPrint[0]["catID"]."'/>\n";
	echo "<input type='hidden' name='completedSteps' value='".applyPipe($applyCompletedSteps)."'/>\n";
}

if($applyEdit && (!$applyConfig['multiStep'] || ($applyConfig['multiStep'] && $catsToPrint[0]["catID"] == $applyCats[count($applyCats)-1]["catID"]) )  )
{
	echo "<p>Please explain what in your app you have edited:<br />\n";
	echo"	<textarea name='appEditUpdate' cols='80' rows = '3'>".$applyForm["appEditUpdate"]."</textarea>\n";
	echo "</p>\n";
}
echo "<div>\n";
if ($applyConfig['multiStep'])
{
	//applycats set at top
	for ($i = 0; $i < count($applyCats); $i++)
	{
		$applyBtnClass = "class='appBtn' onmouseover=\"this.className='appBtn appBtnHov'\" onmouseout=\"this.className='appBtn'\"'";
		if ($i == $catIndex) $applyBtnClass = " disabled class='appBtnCurr' onmouseover=\"this.className='appBtn appBtnHov'\" onmouseout=\"this.className='appBtn'\"";
		else
		{
			if (in_array($applyCats[$i]["catID"], $applyCompletedSteps)) $applyBtnClass = "class='appBtnComplete' onmouseover=\"this.className='appBtnComplete appBtnCompleteHov'\" onmouseout=\"this.className='appBtnComplete'\"";
		}
		echo "<input type='submit' name='submt".$applyCats[$i]["catID"]."' value='".($i+1)."' ".$applyBtnClass."/>\n";
	}
}

echo "<input type='submit' name='submt0' value='Submit Application' class='appBtn' onmouseover=\"this.className='appBtn appBtnHov'\" onmouseout=\"this.className='appBtn'\"/>\n";

echo "<input type='hidden' name='appEdit' value='";
if ($applyEdit) echo $applyEdit;
else echo '0';
echo "' />\n";

echo "</div>\n";
echo "</form>\n";
echo "</div> <!-- end appSecBody -->\n";
echo "<div class='appSecFoot'></div>\n";
include("footer.php");
?>