<?php
/***************************************************
                  Details.php
               Written By: Yume
              Last Update: 2/18/07 (added email notification.)
            
  This page displays all the details for a particular
 applicant. It basically just prints out the row from
 the database after passing everything through the 
 applyNoHTML(). It's important to pass everything through
 this function so that any HTML inserted into the application
 doesn't run as HTML client-side (for security reasons).
  
  Also contains a form to add a comment to this app.
 Said form invokes this page.
****************************************************/

include("header.php");

////////////////Begin Functions////////////////////////

function applyDisplayField($field)
{
	//Takes a field and passes it on to the proper function for printout
	if ($field['fieldType'] == 0) applyDisplayField0($field); // 0 is 'time' type
	if ($field['fieldType'] == 1) applyDisplayField1($field);
	if ($field['fieldType'] == 2) applyDisplayField2($field);
	if ($field['fieldType'] == 3) applyDisplayField3($field);
	if ($field['fieldType'] == 4) applyDisplayField4($field);
	if ($field['fieldType'] == 5) applyDisplayField5($field);
	if ($field['fieldType'] == 6) applyDisplayField6($field);
	if ($field['fieldType'] == 9) applyDisplayField9($field);
}

function applyDisplayField0($field)
{
	//displays a box with the field name and value, formatted with date().
	global $applyMyApp;
	
	$date = applyNoHTML($applyMyApp['app'.$field['fieldID']]);
	
	echo "<b>".$field['fieldName'].":</b> ";
	echo date("g:i a", $date) . "<br />&nbsp;" .  date("m-d-Y", $date);	
}

function applyDisplayField1($field)
{
	//displays a box with the field name and value.
	global $applyMyApp;
	
	echo "<b>".$field['fieldName'].":</b> ";
	echo applyNoHTML($applyMyApp['app'.$field['fieldID']]);
}

function applyDisplayField2($field)
{
	//displays a large box with field name and data.
	global $applyMyApp;
	
	echo "<div class='appMinHead'>";
	echo $field['fieldName'];
	echo "</div>";
	echo "<div class='appMinBody'>";
	echo applyBBCode(applyNoHTML($applyMyApp['app'.$field['fieldID']]));
	echo "</div>\n";
}

function applyDisplayField3($field)
{
	//displays a box with the field name and value.
	global $applyMyApp;
	
	echo "<b>".$field['fieldName'].":</b> ";
	echo applyNoHTML($applyMyApp['app'.$field['fieldID']]);
}

function applyDisplayField4($field)
{
	//displays a box with the field name and value, colored.
	global $applyMyApp;
	
	echo "<b>".$field['fieldName'].":</b> ";
	if ($applyMyApp['app'.$field['fieldID']] == "on") echo "<span class='appPositive'>Yes</span>";
	else echo "<span class='appNegative'>No</span>";
}

function applyDisplayField5($field)
{
	//displays a colored table with availability data
	global $applyMyApp;
	$arr = applyUnPipe($applyMyApp['app'.$field['fieldID']]);
	
	$closed = "<td class = 'appNoAva'></td>";
	$open = "<td class = 'appYesAva'></td>";
	
	echo "<table cellpadding = '1' border = '1'cellspacing = '0'>\n";
	echo "<tr><td></td><td width='30'><b>Mon</b></td><td width='30'><b>Tue</b></td><td width='30'><b>Wed</b></td><td width='30'><b>Thu</b></td><td width='30'><b>Fri</b></td><td width='30'><b>Sat</b></td><td width='30'><b>Sun</b></td></tr>\n";
	$row = array($closed, $closed, $closed, $closed, $closed, $closed, $closed);
	for ($time = 1; $time <= 11; $time++)
	{
		$tick = 0;
		for ($j = 0; $j < count($arr); $j+=2)//check to toggle availability on
		{
			if ($arr[$j] == $time) $row[$tick]=$open;
			if ($arr[$j+1] < $time) $row[$tick]=$closed;//for those loltards who put that they are available after they aren't.
			$tick++;
		}
		$tick = 0;
		for ($j = 1; $j < count($arr); $j+=2)//check to toggle availability off
		{
			if ($arr[$j] == $time) $row[$tick]=$closed;
			$tick++;
		}
		echo "	<tr>";
		echo "<td>".$time.":00 ";
		if ($time < 12) echo "pm";
		else echo "am";
		echo "</td>";
		for ($j = 0; $j < count($row); $j++) echo $row[$j];
		echo "</tr>\n";
	}
	echo "</table>\n";
}

function applyDisplayField6($field)
{
	//prints out the apps spec.
	global $applyMyApp;
	
	$arr = applyUnPipe($applyMyApp['app'.$field['fieldID']]);
	
	echo "<b>Points in ".$arr[1].":</b> ".$arr[0]."<br />\n";
	echo "<b>Points in ".$arr[3].":</b> ".$arr[2]."<br />\n";
	echo "<b>Points in ".$arr[5].":</b> ".$arr[4]."\n";
}

function applyDisplayField9($field)
{
	//oh noes a secret type.
	global $applyMyApp;
	global $applyConfig;
	global $applyUserdata;
	
	if ($field['fieldID'] == "Armory")
	{
		echo "<b>".$field['fieldName'].":</b> ";
		echo $applyMyApp['app'.$field['fieldID']];
	}
	if ($field['fieldID'] == "Status")
	{
		if (($applyConfig['showStatus'] ==  1 && $applyUserdata['isMember']) || ($applyConfig['showStatus'] ==  2))
		{
			echo "<b>".$field['fieldName'].":</b> ";
			echo applyGetStatus($applyMyApp['app'.$field['fieldID']]);
		}
	}
}

function applyPrintCat($myCat)
{
	global $applyPrefix;
	
	echo "<div class='appSecHead'>";
	echo $myCat['catName'];
	echo "</div>\n<div class='appSecBody'>\n";
	echo "<p>\n";
	$fields = applyQuery("SELECT * FROM `".$applyPrefix."fields` WHERE `fieldCat` = '".$myCat['catID']."';");
	$myFields = array();
	while ($field = applyRow($fields)) $myFields[$field['fieldOrder']] = $field;
	applyFree($fields);
	
	$myFieldsSorted = array();
	if ($myCat['catID'] == 1) //if we're doing General Info, add in necessary fields
	{
		array_push($myFieldsSorted, array("fieldID" => "Armory", "fieldCat" => 1, "fieldName" => "Armory Link", "fieldType" => 9, "fieldDesc" => "", "fieldDetails" => 3, "fieldOrder" => 0));
		array_push($myFieldsSorted, array("fieldID" => "UserName", "fieldCat" => 1, "fieldName" => "User Name", "fieldType" => 1, "fieldDesc" => "", "fieldDetails" => 3, "fieldOrder" => 0));
		array_push($myFieldsSorted, array("fieldID" => "Status", "fieldCat" => 1, "fieldName" => "App Status", "fieldType" => 9, "fieldDesc" => "", "fieldDetails" => 0, "fieldOrder" => 0, "fieldRequired" => 0));
		$myFieldsSorted = applyFieldsPopulate($myFieldsSorted);
	}
	$fieldKeys = array_keys($myFields);
	sort($fieldKeys);
	for ($j = 0; $j < count($fieldKeys); $j++)
	{
		array_push($myFieldsSorted, $myFields[$fieldKeys[$j]]);
	}
	for ($j = 0; $j < count($myFieldsSorted); $j++)
	{
		applyDisplayField($myFieldsSorted[$j]);
		echo "<br />\n";
	}
	echo "</p>\n";
	echo "</div>\n";
}

///////////////////// End Functions ////////////////////////////

if (!$_GET['appID']) die('invalid input: an app ID must be specified');
$applyID = $_GET['appID'];

$isValidGuest = 0;
$applyGetApp = applyQuery("SELECT * FROM `".$applyPrefix."apps` WHERE appID = '".$applyID."' LIMIT 1;");
if ($applyApp = applyRow($applyGetApp))
{
	if ($applyApp['appUserName'] == $applyUserdata['userName'])
	{
		$applyIsValidGuest = 1;
	}
}
applyFree($applyGetApp);

if (!$applyUserdata['isMember'] && !$applyIsValidGuest) applyNoAccess(); //Don't let anyone in who isn't a guild member UNLESS they are the owner of the app. THen we'll show it to them but hide private comments.
if($_POST['commSub'] == "yes" && $applyUserdata['isMember'])//if comment was submitted
{
	$applyShare = "0";
	if ($_POST['appShare'] == "on") $applyShare = "1";
	applyMakeComment($applyID, $applyShare, $_POST['appComments']);
}//end comment submission.

if(isset($_POST['appStatus']) && $applyUserdata['isAdmin'])//if comment was submitted
{
	$appStatus = (int)$_POST['appStatus'];
	applyQuery("UPDATE `".$applyPrefix."apps` SET `appStatus` = '".$appStatus ."' WHERE `appID` = '".$applyID."' LIMIT 1;");
	echo "<div class='appFeedback'>The status for this app has been updated.</div>\n";
}//end status change

//Begin printing out the app//
$applyGetApp = applyQuery("SELECT * FROM `".$applyPrefix."apps` WHERE `appID` = '".$applyID."' LIMIT 1;");
if ($applyMyApp = applyRow($applyGetApp))
{
	echo "<div class = 'appSecHead'>" . applyTitle("Details for " . $applyMyApp['appName']) . "</div>\n";
	echo "<div class = 'appSecBody'>\n";

	echo "<table width = '100%'>\n";
	echo "<tr>\n"; //left: app data. right: discussion
	echo "<td style='vertical-align: top; width: 50%;'>\n"; //begin leftside

	$applyMyApp["appArmory"] = "<a href=\"http://armory.worldofwarcraft.com/character-sheet.xml?r=".str_replace(" ", "+", $applyConfig['serverName'])."&n=".$applyMyApp['appName']."\">Link to Armory</a>";
	//get all fields
	$applyCats = applyGetCats();

	for ($i = 0; $i < count($applyCats); $i++) if($applyCats[$i]["catLoc"] == 0) applyPrintCat($applyCats[$i]);

	$applyGetEdits = applyQuery("SELECT * FROM `".$applyPrefix."edits` WHERE `editAppID` = '".$applyID."' ORDER BY `editTime` ASC;");
	$applyCounter = 1;
	if ($applyEdit = applyRow($applyGetEdits))
	{
		echo "<div class = 'appSecHead'>Application Edits</div>\n<div class = 'appSecBody'>\n";
		do {
			echo "<p><b>Edit ".$applyCounter."</b> (".date("g:i a m-d-Y", $applyEdit['editTime'])."):".applyBBCode(applyNoHTML($applyEdit['editDescription']))."</p>\n";
			$applyCounter ++;
		} while ($applyEdit = applyRow($applyGetEdits));
		echo "</div>\n";
	}
	applyFree($applyGetEdits);
	
	echo "</td>\n"; //end leftside
	echo "<td style='vertical-align: top; width: 50%;'>"; //begin rightside

	for ($i = 0; $i < count($applyCats); $i++) if($applyCats[$i]["catLoc"] == 1) applyPrintCat($applyCats[$i]);

	//section for admins to change app's status.
	if ($applyConfig['showStatus'] && $applyUserdata['isAdmin'])
	{
		echo "<div class = 'appSecHead'>Change Status for on " . $applyMyApp['appName'] . "</div>\n<br />\n";
		echo "<form method='post' action='details.php?appID=" . $applyID . "'>\n";
		echo "<select name='appStatus' onchange='javascript:form.submit();'>";
		applyPrintOptions($applyStatusOptions, $applyMyApp['appStatus']);
		echo "</select>\n";
		echo "</form>\n<br />\n";
	}
	
	//Begin Discussion on Applicant Section//
	echo "<div class = 'appSecHead'>Discussion on " . $applyMyApp['appName'] . "</div>\n";
	echo "<table border='0' cellpadding = '2' cellspacing = '0' width = '100%'>";
	$applyComms = applyQuery("SELECT * FROM `".$applyPrefix."comments` WHERE `commAppID` = '".$applyID."' AND `commMemberName` != 'auto' ORDER BY `commTime` ASC;");
	if ($applyComm = applyRow($applyComms))
	{
		do
		{
			if ($applyComm['commShare'] == 1) $applyShared = " <span class = 'appPositive'>Public</span>";
			else $applyShared = " <span class = 'appNegative'>Private</span>";
			$editlinks = "";
			
			if ($applyComm['commMemberName'] == $applyUserdata['userName'] || $applyUserdata['isAdmin']) $applyEditLinks = "<a href = 'post.php?edit=" . $applyComm['commID'] . "&ref=" . $applyID . "'>E</a> <a href = 'post.php?delete=" . $applyComm['commID'] . "&ref=" . $applyID . "'>X</a>";
							
			if ($applyComm['commShare'] == 0)//If the comment is a private comment, check to see if viewer is a guild member or not.
			{
				if ($applyUserdata['isMember'] == 1)
				{
					echo "<tr><td width = '100%'>\n";
					echo "<div class = 'appMinHead'><b>" . $applyComm['commMemberName'] . "</b>&nbsp;<i>" . date("g:i a", $applyComm['commTime']) . " " .  date("m-d-Y", $applyComm['commTime']) . "</i>&nbsp;" . $applyShared . " &nbsp; &nbsp;" . $applyEditLinks . "</div>\n";
					echo applyBBCode($applyComm['commData']) . "<br /><br /></td></tr>\n";
				}
			}
			else //If the app is public, just show it.
			{
				echo "<tr><td width = '100%'>\n";
				echo "<div class = 'appMinHead'><b>" . $applyComm['commMemberName'] . "</b>&nbsp;<i>" . date("g:i a", $applyComm['commTime']) . " " .  date("m-d-Y", $applyComm['commTime']) . "</i>&nbsp;" . $applyShared . " &nbsp; &nbsp;" . $applyEditLinks . "</div>\n";
				echo applyBBCode($applyComm['commData']) . "<br /><br /></td></tr>\n";
			}
		}
		while($applyComm = applyRow($applyComms));
	}
	else
	{
		echo "<tr><td><i>No comments on this applicant yet.</i></td></tr>\n";
	}
	applyFree($applyComms);
	
	echo "</table>";
	if ($applyUserdata['isMember'])
	{
		echo "<p>Add a comment:</p>";
		echo "<form method='post' name='form1' action='details.php?appID=" . $applyID . "'>\n";
		echo "<textarea name=\"appComments\" cols=\"40\" rows = \"7\"></textarea><br />\n";
		echo "<input type = 'hidden' name = 'commSub' value = 'yes'>";
		echo "<input type = 'checkbox' name = 'appShare'>Let the app see this comment<br />\n";
		echo "<input type='submit' value='Submit'  class='appBtn' onmouseover=\"this.className='appBtn appBtnHov'\" onmouseout=\"this.className='appBtn'\">\n";
		echo "</form>\n";
	}
	echo "</td></tr></table>\n";
	//End Discussion on Applicant Section//
}
applyFree($applyGetApp);
echo "</div>\n"; // end appSecBody
echo "<div class = 'appSecFoot'></div>\n";
include('footer.php');
?>