<?php
/***************************************************
                   functions.php
               Written By: Yume
              Last Update: 11/17/08
            
 This page contains various functions for the operation
 of the apply section. is included on every apply page.
  
 This software is licensed under the GPL.
****************************************************/

include("const.php");

function applyQuery($query)
{
	//Submits a query to the database and returns a link for result gathering purposes.
	//Down the line this can be changed to use databases other than mySQL.
	global $doDebug;
	if ($doDebug) echo $query."<br />\n";
	
	$x = mysql_query($query) or die(mysql_error());
	return $x;
}

function applyQueryForce($query)
{
	//Same as applyQuery except it doesnt die on error.

	$x = mysql_query($query);
	return $x;
}

function applySingleQuery($query)
{
	//accepts a query that will only yield a single result. Returns that result.
	global $doDebug;
	if ($doDebug) echo $query."<br />\n";
	
	$result = mysql_query($query) or die(mysql_error());
	$row = mysql_fetch_array($result);
	mysql_free_result($result);
	$output = $row[0];
	return $output;
}

function applyRow($result)
{
	//Takes a link to a db query and returns the next row.
	//Down the line this can be changed to use databases other than mySQL.
	
	$x = mysql_fetch_array($result);
	return $x;
}

function applyFree($handle)
{
	//frees the handle of a query.
	mysql_free_result($handle);
}

function applyTitle($input)
{
	return "<span class='appTitle'>".$input."</span>";
}

function applyInit()
{
	global $applyDBType, $applyDBHost, $applyDBName, $applyDBUser, $applyDBPass, $applyDBForumPrefix;
	
	if ($DBType=="mysql" || $DBType=="mysql4" || $DBType=="mysql5" || $DBType=="")
	{
		$applyConn = mysql_pconnect($applyDBHost, $applyDBUser, $applyDBPass) or die(mysql_error());
		mysql_select_db($applyDBName, $applyConn);	
	}
	applyUpdateSessions();
}

function applyNoQuote($input)
{
	$input = stripslashes($input);
	$out = str_replace("\"", "'", $input);
	return $out;
}

function applyPrintOptions($options, $selected)
{
	//a nifty function to print out option tags for the given array.
	//will add selected parameter if one is selected.
	
	//keys of given array are value field, values of given array is the displayed text.
	
	$keys = array_keys($options);
	
	for ($i = 0; $i < count($options); $i++)
	{
	 	echo "	<option value=\"".$keys[$i]."\"";
		if ($keys[$i] == $selected) echo " selected";
		//else echo $$keys[$i]."!=".$selected."\n";
		echo "> ".$options[$keys[$i]]."</option>\n";
	}
}

//////////////////////////////// Categories //////////////////////////////////
// are really simple.

function applyMakeCat($name, $desc, $order)
{
	//Creates a category.
	global $applyPrefix;
		
	//First, check if name is taken
	$searchResult = applyQuery("SELECT * FROM `".$applyPrefix."categories` WHERE `catName` = \"".applyNoQuote($name)."\";");
	if (applyRow($searchResult))
	{
		echo "That category name already exists.";
		return 0;
	}
	applyFree($searchResult);
	//If name isn't taken, create category
	applyQuery("INSERT INTO `".$applyPrefix."categories` (catName, catDesc, catOrder, catLoc) VALUES (\"".applyNoQuote($name)."\",\"".applyNoQuote($desc)."\",\"".applyNoQuote($order)."\", 0);");
	
	echo "Category <b>".$name."</b> successfully added!<br />\n";
	return 1;
}

function applyDelCat($ID)
{
	//Deletes a category with given id.
	global $applyPrefix;
	
	applyQuery("DELETE FROM `".$applyPrefix."categories` WHERE `catID` = '".$ID."' LIMIT 1;");
	
	echo "Category <b>".$ID."</b> successfully deleted!<br />\n";
	return 1;
}

function applyGetCats()
{
	//returns an array with all categories
	global $applyPrefix;
	
	$applyCats = array();

	$searchResult = applyQuery("SELECT * FROM `".$applyPrefix."categories` ORDER BY `catOrder` ASC;");
	while ($applyRow = applyRow($searchResult)) array_push($applyCats, $applyRow);
	applyFree($searchResult);
	
	return $applyCats;
}

	

//////////////////////////////// Fields /////////////////////////////////////////////
/* When deciding on the db structure for the app table I had 3 options:

1 - have it be a 3 column table (appID, fieldID, fieldData)
I chose not to do this because it's hard to see what's going on when you view such a table in mySQLAdmin

2 - have it be a multicolumn table with column names reflecting the actual field names 
I chose not to do this because illegal characters or long field names might screw it up. This would be optimal for viewing the table though.

3 - have it be a multicolumn table with column names reflecting the field ID values 
I ultimately chose this one because when viewing the table you could get a sense for what's going on (although not perfectly so) but you don't have the same character or length issues as option 2


So here's what the table looks like:

appID | appUserID | appName | appCreated | appUpdated | appLevel | appClass | appRace | app0 | app2 | app3 |
------+-----------+---------+------------+------------+----------+----------+---------+------+------+------+
1     | 42        | Yume    | 111019252  | 112089744  | 70       | Mage     | Human   | on   | DC   | 21   |
2     | 23        | Snovv   | 111039783  | 111039783  | 70       | Warrior  | Human   |      | MA   | ??   |
                                                         This is what a checkbox is like ^
*/

function applyMakeField($name, $cat, $type, $desc, $details, $order, $required)
{
	//Makes a new field.
	global $applyPrefix;
	
	//First check to see if name is in use.
	$search = "SELECT * FROM `".$applyPrefix."fields` WHERE `fieldName` = \"".applyNoQuote($name)."\";";
	$searchResult = applyQuery($search);
	if (applyRow($searchResult))
	{
		echo "That field name already exists.";
		return 0;
	}
	applyFree($searchResult);
	//If name isn't taken, make field
	
	//Add the row to the field table
	$insert = "INSERT INTO `".$applyPrefix."fields` (fieldCat, fieldName, fieldType, fieldDesc, fieldDetails, fieldOrder, fieldRequired) VALUES (\"".applyNoQuote($cat)."\",\"".applyNoQuote($name)."\",\"".applyNoQuote($type)."\",\"".applyNoQuote($desc)."\",\"".applyNoQuote($details)."\",\"".applyNoQuote($order)."\",\"".applyNoQuote($required)."\");";
	applyQuery($insert);
	
	//Change the app table to reflect the new field by adding a new column
	
	$fieldID = applySingleQuery("SELECT fieldID FROM`".$applyPrefix."fields` ORDER BY fieldID DESC LIMIT 1;"); //look up the ID of newly created row

	$type = applyTypeSQL($type, $details);//fetch type info
	
	$column = "ALTER TABLE `".$applyPrefix."apps` ADD `app".$fieldID."` ".$type.";";
	applyQuery($column);
	
	echo "Field <b>".$name."</b> successfully added!<br />\n";
	return 1;
}

function applyDelField($ID)
{
	//Deletes a field with given ID.
	global $applyPrefix;
	
	//First delete the column from the apps table
	applyQuery("ALTER TABLE `".$applyPrefix."apps` DROP `app".$ID."`;");
	
	//Now remove the row from the fields table
	applyQuery("DELETE FROM `".$applyPrefix."fields` WHERE `fieldID` = \"".applyNoQuote($ID)."\" LIMIT 1;");
	
	echo "Field <b>".$ID."</b> successfully deleted<br />\n";
	return 1;
}

function applyGetAllFields($time=0)
{
	//returns an array with all fields in it.
	global $applyPrefix;
	
	$applyFields = array();
	if ($time) $applyFields = applyFieldsPopulateTime($applyFields);
	$applyFields = applyFieldsPopulate($applyFields);
	$applyFindFields = applyQuery("SELECT * FROM `".$applyPrefix."fields`;");
	while ($applyRow = applyRow($applyFindFields)) array_push($applyFields, $applyRow);
	applyFree($applyFindFields);
	return $applyFields;
}

function applyFieldsPopulateTime($arr)
{
	//puts 'hidden' fields into the fields array 
	array_push($arr, array("fieldID" => "UserName", "fieldCat" => 1, "fieldName" => "User Name", "fieldType" => 1, "fieldDesc" => "", "fieldDetails" => 3, "fieldOrder" => 0, "fieldRequired" => 0));
	array_push($arr, array("fieldID" => "UserEmail", "fieldCat" => 1, "fieldName" => "User Email", "fieldType" => 1, "fieldDesc" => "", "fieldDetails" => 3, "fieldOrder" => 0, "fieldRequired" => 0));
	array_push($arr, array("fieldID" => "Created", "fieldCat" => 1, "fieldName" => "Date Created", "fieldType" => 0, "fieldDesc" => "", "fieldDetails" => 0, "fieldOrder" => 0, "fieldRequired" => 0));
	array_push($arr, array("fieldID" => "Updated", "fieldCat" => 1, "fieldName" => "Date Updated", "fieldType" => 0, "fieldDesc" => "", "fieldDetails" => 0, "fieldOrder" => 0, "fieldRequired" => 0));
	array_push($arr, array("fieldID" => "NumComments", "fieldCat" => 1, "fieldName" => "Comms", "fieldType" => 0, "fieldDesc" => "", "fieldDetails" => 0, "fieldOrder" => 0, "fieldRequired" => 0));
	array_push($arr, array("fieldID" => "LastComment", "fieldCat" => 1, "fieldName" => "Last Comment", "fieldType" => 0, "fieldDesc" => "", "fieldDetails" => 0, "fieldOrder" => 0, "fieldRequired" => 0));
	array_push($arr, array("fieldID" => "Status", "fieldCat" => 1, "fieldName" => "App Status", "fieldType" => 9, "fieldDesc" => "", "fieldDetails" => 0, "fieldOrder" => 0, "fieldRequired" => 0));
	return $arr;
}


function applyFieldsPopulate($arr)
{
	//populates given array with category 1 necessary fields
	array_push($arr, array("fieldID" => "Name", "fieldCat" => 1, "fieldName" => "Name", "fieldType" => 1, "fieldDesc" => "", "fieldDetails" => 32, "fieldOrder" => 0, "fieldRequired" => 1));
	array_push($arr, array("fieldID" => "Level", "fieldCat" => 1, "fieldName" => "Level", "fieldType" => 1, "fieldDesc" => "", "fieldDetails" => 3, "fieldOrder" => 0, "fieldRequired" => 1));
	array_push($arr, array("fieldID" => "Class", "fieldCat" => 1, "fieldName" => "Class", "fieldType" => 3, "fieldDesc" => "", "fieldDetails" => applyGetClasses(), "fieldOrder" => 0, "fieldRequired" => 1));
	array_push($arr, array("fieldID" => "Race", "fieldCat" => 1, "fieldName" => "Race", "fieldType" => 3, "fieldDesc" => "", "fieldDetails" => applyGetRaces(), "fieldOrder" => 0, "fieldRequired" => 1));	
	return $arr;
}

function applyNoHTML($inp)
{
	return str_replace("<", "&lt;", $inp);
}

function applyFieldByID(&$fields, $ID)
{
	for ($i = 0; $i < count($fields); $i++)
	{
		if ($fields[$i]["fieldID"] == $ID) return $fields[$i];
	}
	return 0;
}

function applyPrintClassIcon($class)
{
	echo "<img src='pics/".strtolower($class)."1.gif'>";
}

/////////////////////////////// Types //////////////////////////////////////////////////////
//Types are hard-coded and not customizable.

/*types are as follows:
1 - standard single line input (technically stored as a string but data could be int or string) - max length stored in details column
2 - block of text (blob)
3 - multiple choice (string)- choices stored in the details column as pipe-delimited
4 - checkbox (string)
5 - availability (encoded string) (sunStart|sunEnd|monStart|monEnd etc...)
6 - Talent Build (encoded string) (tree1No|tree1Name|tree2No|tree2Name etc...)
7 - i dunno, some sort of secret type. maybe its for links
*/

function applyTypeSQL($type, $details)
{
	//Returns mysql type info for given type.
	global $applyPrefix;
	
	$types = array();
	if (!$details) $details = 32;
	$types[1] = "VARCHAR( ".$details." ) NOT NULL";
	$types[2] = "BLOB NOT NULL";
	$types[3] = "VARCHAR( 64 ) NOT NULL";
	$types[4] = "VARCHAR( 3 ) NOT NULL";
	$types[5] = "VARCHAR( 64 ) NOT NULL";
	$types[6] = "VARCHAR( 64 ) NOT NULL";
	
	return $types[$type];
}

function applyGetType($type)
{
	//takes the type number and returns the description
	if ($type == 1) return "single-line text";
	if ($type == 2) return "multi-line text";
	if ($type == 3) return "multiple choice";
	if ($type == 4) return "checkbox";
	if ($type == 5) return "availability";
	if ($type == 6) return "talent build";
	if ($type == 7) return "link";
	return 0;
}

function applyGetTypeDetails($type)
{
	//takes the type number and returns a description of what the type details field does
	if ($type == 1) return "Details is the # of letters/numbers the field can be";
	if ($type == 2) return "Details doesn't do anything";
	if ($type == 3) return "Details must be a pipe-delimited string of the options (ie option 1|option 2|...).";
	if ($type == 4) return "For details, entering disabled makes the checkbox disabled";
	if ($type == 5) return "Details doesn't do anything";
	if ($type == 6) return "Details doesn't do anything";
	if ($type == 7) return "Details not implemented? oh snap.";
	return 0;
}

////////////////////////////////// Classes Functions ///////////////////////////////////////////

function applyGetClasses()
{
	//Returns a pipe-delimited string of classes.
	global $applyClasses;
	
	$out = "";
	$applyClassesKeys = array_keys($applyClasses);
	for ($i = 0; $i < count($applyClasses); $i++)
	{
		if ($i > 0) $out .=  "|";
		$out .=$applyClassesKeys[$i];
	}
	
	return $out;
}

function applyGenClassJS()
{
	global $applyClasses;
	//prints out a javascript with class tree information.
	
	echo "<script type='text/javascript'>\n";
	
	$applyClassesKeys = array_keys($applyClasses);
	for ($i = 0; $i < count($applyClassesKeys); $i++)
	{
		echo "var ".str_replace(' ', '', $applyClassesKeys[$i])."Array =  new Array(";
		for ($j = 0; $j < count($applyClasses[$applyClassesKeys[$i]]); $j++)
		{
			if ($j > 0) echo ", ";
			echo "\"".$applyClasses[$applyClassesKeys[$i]][$j]."\"";
		}
		echo ");\n";
	}
	echo "</script>\n";
	return 1;
}



////////////////////////////// Config Functions /////////////////////////////////////////

function applyAddConfig($name, $data)
{
	//add a row to the config table
	global $applyPrefix;
	
	applyQuery("INSERT INTO `".$applyPrefix."config` (`configName`, `configData`) VALUES (\"".applyNoQuote($name)."\",\"".applyNoQuote($data)."\");");
	
	echo "Config entry <b>".$name."</b> successfully added!<br />\n";
	return 1;
}

function applyUpdateConfig($name, $data)
{
	//update a row in the config table
	global $applyPrefix;
	
	applyQuery("UPDATE `".$applyPrefix."config` SET `configData` = \"".applyNoQuote($data)."\" WHERE `configName` = \"".applyNoQuote($name)."\";");
	
	echo "Config entry <b>".$name."</b> successfully updated!<br />\n";
	return 1;
}

function applyAddWords($name, $data)
{
	//add a row to the words table
	global $applyPrefix;
	
	applyQuery("INSERT INTO `".$applyPrefix."words` (`wordsName`, `wordsData`) VALUES (\"".applyNoQuote($name)."\",\"".applyNoQuote($data)."\");");
	
	echo "Words entry <b>".$name."</b> successfully added!<br />\n";
	return 1;
}

function applyUpdateWords($ID, $name, $data)
{
	//update a row in the words table
	global $applyPrefix;
	
	applyQuery("UPDATE `".$applyPrefix."words` SET `wordsData` = \"".applyNoQuote($data)."\", `wordsName` = \"".applyNoQuote($name)."\" WHERE `wordsID` = \"".applyNoQuote($ID)."\";");
	
	echo "Words entry <b>".$name."</b> successfully updated!<br />\n";
	return 1;
}

function applyPopulateRecruit()
{
	//adds config values for recruitment
	global $applyPrefix;
	
	applyQuery("DELETE FROM `".$applyPrefix."config` WHERE `configName` LIKE \"recruit%%\";");//perform deletion of the comment
	
	$classes = applyUnPipe(applyGetClasses());
	
	for ($i = 0; $i < count($classes); $i++)
	{
		applyAddConfig("recruit".$classes[$i],0);
	}
	applyAddConfig("recruitUpdated",time());
}

function applyClearTables()
{
	//don't call this function.
	global $applyPrefix;
	applyQuery("DROP TABLE `".$applyPrefix."apps`;");
	applyQuery("CREATE TABLE `".$applyPrefix."apps` (`appID` INT NOT NULL AUTO_INCREMENT ,`appUserName` VARCHAR( 32 ) NOT NULL ,`appUserEmail` VARCHAR( 64 ) NOT NULL ,`appName` VARCHAR( 32 ) NOT NULL ,`appCreated` INT NOT NULL ,`appUpdated` INT NOT NULL ,`appLevel` TINYINT NOT NULL ,`appClass` VARCHAR( 32 ) NOT NULL ,`appRace` VARCHAR( 32 ) NOT NULL ,`appNumComments` TINYINT NOT NULL ,`appLastComment` INT NOT NULL,`appStatus` TINYINT NOT NULL ,PRIMARY KEY ( `appID` ));");
	applyQuery("TRUNCATE TABLE `".$applyPrefix."categories`;");
	applyQuery("TRUNCATE TABLE `".$applyPrefix."comments`;");
	applyQuery("TRUNCATE TABLE `".$applyPrefix."config`;");
	applyQuery("TRUNCATE TABLE `".$applyPrefix."edits`;");
	applyQuery("TRUNCATE TABLE `".$applyPrefix."fields`;");
	applyQuery("TRUNCATE TABLE `".$applyPrefix."sessions`;");
	applyQuery("TRUNCATE TABLE `".$applyPrefix."words`;");
	return 1;
}

function applyUnPipe($myInput)
{
	//Takes a pipe-delimited string and returns an array.
	$split = explode("|", $myInput);
	return $split;
}

function applyPipe($myArr)
{
	//Takes an array and returns a pipe-delimited string.
	$out = "";
	for ($i = 0; $i < count($myArr); $i++)
	{
		if ($i > 0) $out .= "|";
		$out .= $myArr[$i];
	}
	return $out;
}

//////////////////////////Login Stuff //////////////////////////

function applyGetConfig()
{
	global $applyPrefix, $applyConfig;
	
	$config = applyQuery("SELECT * FROM `".$applyPrefix."config`;");
	while ($row = applyRow($config))
	{
		$applyConfig[$row['configName']] = $row['configData'];
	}
	applyFree($config);
	return 1;
}

function applyRequireLoggedIn()
{
	//requires user be logged in
	global $applyUserdata, $applyForumPath;
	
	if ($applyUserdata['isLoggedIn']) return 1;
	
	echo "You must be logged into the <a href='".$applyForumPath."'>forums</a> in order to view this page.";
	include("footer.php");
	die();
}

function applyRequireAdmin()
{
	//requires user to be an admin
	global $applyUserdata;
	
	if ($applyUserdata['isAdmin']) return 1;
	
	echo "Not Authorized.";
	include("footer.php");
	die();
}
function applyNoAccess()
{
	//automatically ends page giving 'insufficient priviledges' error.

	echo "Insufficient priviledges.";
	include("footer.php");
	die();
}

////////////////////////////Sessions Stuff////////////////////////

function applyUpdateSessions()
{
	//removes expired sessions
	global $applyPrefix, $dontLogin;
	if ($dontLogin) return 1;
	
	applyQuery("DELETE FROM `".$applyPrefix."sessions` WHERE `sessionTime` < ".time().";");
}

function applyVerifySession($sessionID)
{
	//checks a session ID against the database.
	
	//returns 0 if no access
	//returns 1 if logged in but not guild member or admin
	//returns 2 if logged in and is guild member
	//returns 3 if logged in and is admin

	global $applyPrefix;
	$result = applyQuery("SELECT `sessionPermissions` FROM `".$applyPrefix."sessions` WHERE `sessionID` = \"".applyNoQuote($sessionID)."\";");
	if ($permissions = applyRow($result))
	{
		$permissions = $permissions[0];
		echo "returning:".$permissions;
		return $permissions;
	}
	return 0;
}

function applyMakeSession($session)
{
	//makes a session and inserts into the DB
	//returns the session ID
	global $applyPrefix, $applyUserdata, $dontLogin;
	
	if ($dontLogin) return 1;
	
	$time = time()+3600;
	
	$permissions = 0;
	if ($applyUserdata['isLoggedIn']) $permissions = 1;
	if ($applyUserdata['isMember']) $permissions = 2;
	if ($applyUserdata['isAdmin']) $permissions = 3;
	
	applyQuery("INSERT INTO `".$applyPrefix."sessions` (sessionID, sessionTime, sessionPermissions) VALUES (\"".applyNoQuote($session)."\",\"".applyNoQuote($time)."\",\"".applyNoQuote($permissions)."\");");
	
	return $session;
}


////////////////////////////Comments Stuff////////////////////////


function applyMakeComment($ID, $share, $comment)
{
	global $applyPrefix, $applyUserdata, $applyConfig;
	
	//post comment
	applyQuery("INSERT INTO `".$applyPrefix."comments` (`commAppID`, `commShare`, `commMemberName`, `commTime`, `commData`) VALUES (\"".applyNoQuote($ID)."\", \"".applyNoQuote($share)."\", \"".$applyUserdata['userName']."\", '".time()."', \"".applyNoQuote($comment)."\");");
	
	//increment # of comments field in apps table... again we have to do this because DB might not support subqueries
	$count = (int)applySingleQuery("SELECT `appNumComments` FROM `".$applyPrefix."apps` WHERE `appID` = '".$ID."';");
	$count++;
	
	//make the change
	applyQuery("UPDATE `".$applyPrefix."apps` SET `appNumComments` = '".$count."' WHERE `appID` = '".$ID."';");	

	//change latest post in apps table
	//first get the id from the comment we just submitted	
	$commID = applySingleQuery("SELECT `commID` from `".$applyPrefix."comments` ORDER BY `commID` desc LIMIT 1;");
	
	//make the change
	applyQuery("UPDATE `".$applyPrefix."apps` SET `appLastComment` = '".$commID."' WHERE `appID` = '".$ID."';");
	
	if ($share && $applyConfig['emailNotify'])
	{
		$getAppEmail = applyQuery("SELECT * FROM `".$applyPrefix."apps` WHERE `appID` = '".$ID."';");
		$appFull = applyRow($getAppEmail);
		applyFree($getAppEmail);
		$appEmail = $appFull['appUserEmail'];
		$to = $appEmail;
		
		if ($to)
		{
			$subject = $applyConfig['guildName']." Application Feedback Received";
			$body = "Greetings " . $appFull["appName"] . ", you are receiving this email because you have received a feedback to your application on the ".$applyConfig['guildName']." guild website. Please view your application at ".$applyConfig['domainName'].$applyConfig['dirPath']."details.php?appID=".$ID." to see your feedback. Thanks for your interest in ".$applyConfig['guildName']."!";
			if (mail($to, $subject, $body, "From: ".$applyConfig['webEmail'])) echo("<div class='appFeedback'>Email notification successfully sent!<br />");
			else echo("<div class='appWarning'>Email notification delivery failed...<br />");
		}
		else echo "<div class='appWarning'>Email notification failed - couldn't find email address.<br />";
	}
	else echo "<div class='appFeedback'>\n";
	echo "Your Comments have been added.";
	echo "</div>\n";
}

function applyEditComment($ID, $ref, $data, $share)
{
	//edits a comment.
	//ID is comment ID, ref is app ID.
	global $applyPrefix;
	
	applyQuery("UPDATE `".$applyPrefix."comments` SET `commData` = \"".applyNoQuote($data)."\", `commShare` = \"".$share."\" WHERE `commID` = \"".$ID."\";");
	echo "<div class = 'appSecHead'>" . applyTitle("Your Post has been edited") . "</p></div>\n";
	echo "<div class = 'appSecBody'>\n";
	
	echo "<p><a href = 'details.php?appID=".$ref."'>Return to app details</a></p>\n";
	echo "<p><a href = 'viewApps.php'>Return to view all apps</a></p>\n";
	
	echo "</div>";
	echo "<div class='appSecFoot'></div>\n";
}

function applyDeleteComment($ID, $ref) 
{
	//deletes a comment
	//ID is the ID of the comment we're deleting. ref is the ID of the app.
	global $applyPrefix, $applyUserdata;
	
	echo "<div class = 'appSecHead'>" . applyTitle("Post Deleted") . "</div>\n";
	echo "<div class = 'appSecBody'>\n";
	applyQuery("DELETE FROM `".$applyPrefix."comments` WHERE `commID` = '".$ID."';");//perform deletion of the comment

	$count = applySingleQuery("SELECT `appNumComments` FROM `".$applyPrefix."apps` WHERE `appID` = '".$ref."';");
	$count--;
	
	applyQuery("UPDATE `".$applyPrefix."apps` SET `appNumComments` = '".$count."' WHERE `appID` = '".$ref."';");//update # of comments. damn lack of subqueries

	$findNextComm = applyQuery("SELECT * FROM `".$applyPrefix."comments` WHERE `commAppID` = '".$ref."' ORDER BY `commTime` DESC;"); //find the most recent comment for that app.
	$nextComm = applyRow($findNextComm);
	
	applyFree($findNextComm);

	applyQuery("UPDATE `".$applyPrefix."apps` SET `appLastComment` = '".$nextComm['commID']."' WHERE `appID` = '".$ref."';"); // update most recent comment field.
		
	echo "<p><a href = 'details.php?appID=".$ref."'>Return to app details</a></p>\n";
	echo "<p><a href = 'viewApps.php'>Return to view all apps</a></p>\n";
	echo "</div>\n"; //end appSecBody
	echo "<div class='appSecFoot'></div>\n";
}

function applyGetStatus($status)
{
	//prints out the status.
	
	//0 = no status
	//1 = under consideration
	//2 = rejected
	//3 = accepted
	if ($status == 0) return "<span> </span>\n";
	if ($status == 1) return "<span class='appNeutral'>Under Consideration</span>\n";
	if ($status == 2) return "<span class='appNegative'>Rejected</span>\n";
	if ($status == 3) return "<span class='appPositive'>Accepted</span>\n";
	return 0;
}

function applyDelApp($ID)
{
	global $applyPrefix;
	//deletes app from database.
	
	$name = applySingleQuery("SELECT `appName` from `".$applyPrefix."apps` WHERE `appID` = '".$ID."' LIMIT 1;");
	
	applyQuery("DELETE FROM `".$applyPrefix."apps` WHERE `appID` = '".$ID."' LIMIT 1;");
	applyQuery("DELETE FROM `".$applyPrefix."comments` WHERE `commAppID` = '".$ID."';");
	echo "<div class='appFeedback'><p><b>".$name."</b>'s application has been deleted.</p></div>\n";
	return 1;
}

function applyVerifyDelApp($ID, $pageName)
{
	///prints out a form requesting user to verify their request to delete an app
	global $applyPrefix;
	
	$name = applySingleQuery("SELECT `appName` from `".$applyPrefix."apps` WHERE `appID` = '".$ID."' LIMIT 1;");

	
	echo "<div class='appWarning' >";
	echo "<p>Are you sure you want to delete the application for " . $name . "?</p>\n";
	echo "<form method='post' action='".$pageName."?delete=" . $ID . "'>\n";
	echo "<p><input type='submit' name='verify' value='yes' class='appBtn' onmouseover=\"this.className='appBtn appBtnHov'\" onmouseout=\"this.className='appBtn'\" /> <input type='submit' name='verify' value='no' class='appBtn' onmouseover=\"this.className='appBtn appBtnHov'\" onmouseout=\"this.className='appBtn'\" /></p>\n";
	echo "</form>\n";
	echo "</div>";	
}



function applyGetRaces()
{
	//Returns a pipe-delimited string of races.
	global $applyConfig;
	
	return $applyConfig['races'];
	
}

///////////////////Installation Stuff/////////////////////////////////////

function applyMakeConfig($path, $type, $prefix, $ID, $applyDB, $adminID)
{
	//generates config file, grabbing settings from original config file. ID is forum ID number
	$out = "<?php\n";
	$out .= "\$applyDBType = \"".$applyDB['type']."\";\n";
	$out .= "\$applyDBHost = \"".$applyDB['host']."\";\n";
	$out .= "\$applyDBName = \"".$applyDB['name']."\";\n";
	$out .= "\$applyDBUser = \"".$applyDB['user']."\";\n";
	$out .= "\$applyDBPass = \"".$applyDB['pass']."\";\n";
	$out .= "\$applyDBForumPrefix = \"".$applyDB['forumPrefix']."\";\n";
	$out .= "\$applyForumType = \"".$type."\";\n";
	$out .= "\$applyForumPath = \"".$path."\";\n";
	$out .= "\$applyForumMemberID = \"".$ID."\";\n";
	$out .= "\$applyPrefix = \"".$prefix."\";\n";
	$out .= "\$applyAdminPermissions = \"".$adminID."\";\n";
	$out .= "?>\n";
	$Handle = fopen("config.php", 'w');
	fwrite($Handle, $out);
	fclose($Handle);
	return 1;
}

function applyFindPath()
{
	global $_SERVER;
	$myPath = "";
	$path = $_SERVER["SCRIPT_NAME"];
	$parts = explode("/", $path);
	for ($i = 0; $i < count($parts)-1; $i++)
	{
		if ($parts[$i] != "")
		{
			$myPath .= "/".$parts[$i];
		}
	}
	$myPath .= "/";
	
	return $myPath;
}

function applyBBCode(&$message)
{
	//stolen + modified from eqdkp.
	//eventually, replace this with a call to the forums built in bbcode parser.
	
	// Pad message with a space so we can match things at the start of the first line
	$message = ' ' . $message;
	$message = preg_replace("#(\\\){1,}(\"|\'|\&quot;|\&\#039)#", "\"", $message);
	$message = preg_replace("((\r\n))"," <br />\n", $message);
	
	$quote_open = '<table width="90%" border="0" cellspacing="0" cellpadding="3" align="center"><tr><td class="quote'.$quote_class.'"><b>'.$user->lang['quote'].':</b></td></tr><tr><td class="quote'.$quote_class.'">';
	$quote_close = '</td></tr></table>';
	
	// Patterns and replacements
	$patterns = array();
	$replacements = array();
	
	// [img]image_url[/img]
	$patterns[0] = "#\[img\](.*?)\[/img\]#si";
	$replacements[0] = "<img src=\"\\1\" alt=\"User-posted image\" />";
	
	// [url]xxxx://www.example.com[/url]
	$patterns[1] = "#\[url\]([a-z]+?://){1}([a-z0-9\-\.,\?!%\*_\#:;~\\&$@\/=\+]+)\[/url\]#si";
	$replacements[1] = "<a href=\"\\1\\2\">\\1\\2</a>";
	
	// [url]www.example.com[/url]
	$patterns[2] = "#\[url\]([a-z0-9\-\.,\?!%\*_\#:;~\\&$@\/=\+]+)\[/url\]#si";
	$replacements[2] = "<a href=\"http://\\1\">\\1</a>";
	
	// [url=xxxx://www.example.com]Example[/url]
	$patterns[3] = "#\[url=([a-z]+?://){1}([a-z0-9\-\.,\?!%\*_\#:;~\\&$@\/=\+]+)\](.*?)\[/url\]#si";
	$replacements[3] = "<a href=\"\\1\\2\">\\3</a>";
	
	// [url=www.example.com]Example[/url]
	$patterns[4] = "#\[url=([a-z0-9\-\.,\?!%\*_\#:;~\\&$@\/=\+]+)\](.*?)\[/url\]#si";
	$replacements[4] = "<a href=\"\\1\">\\2</a>";
	
	// [url=mailto:user@example.com]E-Mail[/url]
	$patterns[5] = "#\[url=mailto:([a-zA-Z0-9]+[\.a-zA-Z0-9_-]*@[a-zA-Z0-9_-]+\.[a-zA-Z0-9_-]+)\](.*?)\[/url\]#si";
	$replacements[5] = "<a href=\"mailto:\\1\">\\2</a>";
	
	
	$count = sizeof($patterns);
	if ( @is_object($pm) )
	{
		$plugin_news = $pm->do_hooks('news_parse');
		foreach ( $plugin_news as $news_array )
		{
			foreach ( $news_array as $find_replace )
			{
				if ( (isset($find_replace['patterns'])) && (isset($find_replace['replacements'])) )
				{
					$count++;
					$patterns[$count] = $find_replace['patterns'];
					$replacements[$count] = $find_replace['replacements'];
				}
			}
		}
	}
	
	$ascii = "......................................__................................................<br />.............................,-~*`lllllll`*~,..........................................<br />.......................,-~*`lllllllllllllllllllllllllll`*-,....................................<br />..................,-~*llllllllllllllllllllllllllllllllllllllllllll*-,..................................<br />...............,-*llllllllllllllllllllllllllllllllllllllllllllllllllllll.\.................................<br />.............;*`lllllllllllllllllllllllllll,-~*~-,llllllllllllllllllll\................................<br />..............\lllllllllllllllllllllllllll/.........\;;;;llllllllllll,-`~-,...........................<br />...............\lllllllllllllllllllll,-*...........`~-~-,...(.(`*,`,..........................<br />................\llllllllllll,-~*.....................)_-\..*`*;..)..........................<br />.................\,-*`,*`)............,-~*`~................/.....................<br />..................|/.../.../~,......-~*,-~*`;................/.\..................<br />................./.../.../.../..,-,..*~,.`*~*................*...\.................<br />................|.../.../.../.*`...\...........................)....)`~,..................<br />................|./.../..../.......)......,.)`*~-,............/....|..)...`~-,.............<br />..............././.../...,*`-,.....`-,...*`....,---......\..../...../..|.........```*~-,,,,<br />...............(..........)`*~-,....`*`.,-~*.,-*......|.../..../.../............\........<br />................*-,.......`*-,...`~,..``.,,,-*..........|.,*...,*...|..............\........<br />...................*,.........`-,...)-,..............,-*`...,-*....(`-,............\.......<br />......................f`-,.........`-,/...*-,___,,-~*....,-*......|...`-,..........\........<br />";
	
	
	$message = preg_replace($patterns, $replacements, $message);
	
	$message = str_replace('[b]', '<b>', $message);
	$message = str_replace('[/b]', '</b>', $message);
	
	$message = str_replace('[i]', '<i>', $message);
	$message = str_replace('[/i]', '</i>', $message);
	
	$message = str_replace('[u]', '<u>', $message);
	$message = str_replace('[/u]', '</u>', $message);
	
	$message = str_replace('[center]', '<div style = "text-align: center;">', $message);
	$message = str_replace('[/center]', '</div>', $message);
	
	$message = str_replace('[forehead]', $ascii, $message);
	
	if ( $parse_quotes )
	{
	    $message = str_replace('[quote]', $quote_open, $message);
	    $message = str_replace('[/quote]', $quote_close, $message);
	}
	
	// Undo our pad
	$message = substr($message, 1);
	
	$message = applyTruncURL($message, 35);
	
	return $message;
}

function applyTruncLink($url, $mode='0', $trunc_before='', $trunc_after='...') {
    if (1 == $mode) {
                $url = preg_replace("/(([a-z]+?):\\/\\/[A-Za-z0-9\-\.]+).*/i", "$1", $url);
                $url = $trunc_before . preg_replace("/([A-Za-z0-9\-\.]+\.(com|org|net|gov|edu|us|info|biz|ws|name|tv)).*/i", "$1", $url) . $trunc_after;
        } elseif (($mode > 10) && (strlen($url) > $mode)) {
                $url = $trunc_before . substr($url, 0, $mode) . $trunc_after;
        }
        return $url;
} //end c2c_truncate_link()

// mode: 0=full url; 1=host-only ;11+=number of characters to truncate after
function applyTruncURL($text, $mode='0', $trunc_before='', $trunc_after='...', $open_in_new_window=true) {
    $text = ' ' . $text . ' ';
    $new_win_txt = ($open_in_new_window) ? ' target="_blank"' : '';
        
    // Hyperlink Class B domains *.(com|org|net|gov|edu|us|info|biz|ws|name|tv)(/*)
    $text = preg_replace("#([\s{}\(\)\[\]])([A-Za-z0-9\-\.]+)\.(com|org|net|gov|edu|us|info|biz|ws|name|tv)((?:/[^\s{}\(\)\[\]]*[^\.,\s{}\(\)\[\]]?)?)#ie",
        "'$1<a href=\"http://$2.$3$4\" title=\"http://$2.$3$4\"$new_win_txt>' . applyTruncLink(\"$2.$3$4\", \"$mode\", \"$trunc_before\", \"$trunc_after\") . '</a>'",
        $text);

    // Hyperlink anything with an explicit protocol
    $text = preg_replace("#([\s{}\(\)\[\]])(([a-z]+?)://([A-Za-z_0-9\-]+\.([^\s{}\(\)\[\]]+[^\s,\.\;{}\(\)\[\]])))#ie",
        "'$1<a href=\"$2\" title=\"$2\"$new_win_txt>' . applyTruncLink(\"$4\", \"$mode\", \"$trunc_before\", \"$trunc_after\") . '</a>'",
                $text);

    // Hyperlink e-mail addresses
    $text = preg_replace("#([\s{}\(\)\[\]])([A-Za-z0-9\-_\.]+?)@([^\s,{}\(\)\[\]]+\.[^\s.,{}\(\)\[\]]+)#ie",
        "'$1<a href=\"mailto:$2@$3\" title=\"mailto:$2@$3\">' . applyTruncLink(\"$2@$3\", \"$mode\", \"$trunc_before\", \"$trunc_after\") . '</a>'",
        $text);

    return substr($text,1,strlen($text)-2);
} //end c2c_hyperlink_urls()
?>