<?php
/***************************************************
                   init.php
               Written By: Yume
              Last Update: 11/17/08
            
 Has various function calls for setting up a default
 application installation.
 
 This software is licensed under the GPL.
****************************************************/

//Note: It's not a security problem to leave this file lying around since it has to be imported by another file to connect to the DB.
//      Calling it directly won't do jack

if (!$myRaces) $myRaces = "Draenei|Dwarf|Gnome|Human|Night Elf";

applyClearTables();

//populate config
applyAddConfig("races", $myRaces);
applyAddConfig("guildName", "Your Guild Name");
applyAddConfig("domainName", "www.yourDomainName.com");
applyAddConfig("numApps", "25");
applyAddConfig("viewApps", "Icon|Name/Level-Class|8|Created|Updated|NumComments|LastComment");
applyAddConfig("webEmail", "");
applyAddConfig("emailNotify", "1");
applyAddConfig("dirPath", applyFindPath());
applyAddConfig("serverName", "");
applyAddConfig("classSort", "0");
applyAddConfig("multiStep", "0");
applyAddConfig("version", "0.60");
applyAddConfig("showStatus", "0");
//make recruitment config values
applyGetConfig();
applyPopulateRecruit();
applyGetConfig();

applyAddWords("Current Recruitment Status - %t", '');
applyAddWords("Recruitment Steps", '');
applyAddWords("Recruitment Guidelines", '');

//make categories
//function applyMakeCat($name, $desc, $order)
applyMakeCat("General Information", "", 1);
applyMakeCat("Character Information", "", 2);
applyMakeCat("Availability", "", 3);
applyMakeCat("Attunement", "", 4);
applyMakeCat("Other Information", "", 5);

//make fields
//applyMakeField($name, $cat, $type, $desc, $details, $order, $required)
applyMakeField("Age", 1, 1, "", 2, 1, 0);
applyMakeField("Location", 1, 1, "", 32, 2, 0);
applyMakeField("Reference(s)", 1, 1, "", 64, 3, 0);
applyMakeField("Profession 1", 1, 3, "", "Alchemy|Blacksmithing|Enchanting|Engineering|Herbalism|Inscription|JewelCrafting|Leatherworking|Mining|Skinning|Tailoring", 4, 0);
applyMakeField("Profession 2", 1, 3, "", "Alchemy|Blacksmithing|Enchanting|Engineering|Herbalism|Inscription|JewelCrafting|Leatherworking|Mining|Skinning|Tailoring", 5, 0);
applyMakeField("Have Ventrilo", 1, 4, "", "", 6, 0);
applyMakeField("Working Microphone", 1, 4, "", "", 7, 0);

applyMakeField("Current Spec", 2, 6, "", "", 1, 0);
applyMakeField("Willing to respec", 2, 4, "I am willing to respec at any time to benefit the guilds needs.", "",  2, 0);
applyMakeField("Unbuffed Fire Resist", 2, 1, "", 3, 3, 0);
applyMakeField("Unbuffed Nature Resist", 2, 1, "", 3, 4, 0);
applyMakeField("Unbuffed Shadow Resist", 2, 1, "", 3, 5, 0);
applyMakeField("Unbuffed Frost Resist", 2, 1, "", 3, 6, 0);

applyMakeField("Availability", 3, 5, "Note: times listed are server time (CST)", "", 1, 0);

applyMakeField("WarpForged Key", 4, 4, "Tempest Keep Heroic", "", 1, 0);
applyMakeField("Auchenai Key", 4, 4, "Auchindoun Heroic", "", 2, 0);
applyMakeField("Flamewrought Key", 4, 4, "Hellfire Citadel Heroic", "", 3, 0);
applyMakeField("Key of Time", 4, 4, "Caverns of Time Heroic", "", 4, 0);
applyMakeField("Reservoir Key", 4, 4, "Coilfang Reservoir Heroic", "", 5, 0);
applyMakeField("Karazan", 4, 4, "", "", 6, 0);
applyMakeField("Eye of the Storm", 4, 4, "", "", 7, 0);
applyMakeField("The Black Temple", 4, 4, "", "", 8, 0);
applyMakeField("Serpentshrine Cavern", 4, 4, "", "", 9, 0);
applyMakeField("Mt. Hyjal", 4, 4, "", "", 10, 0);

applyMakeField("Previous MMO Experience", 5, 2, "", "", 1, 0);
applyMakeField("Previous Guilds", 5, 2, "", "", 2, 0);
applyMakeField("Comments", 5, 2, "", "", 3, 0);

applyMakeComment(0,0,0);
applyQuery("UPDATE `".$applyPrefix."comments` SET `commID` = '0' WHERE `commID` = 1 LIMIT 1 ;");
?>
