<?php
/***************************************************
                   install.php
               Written By: Yume
              Last Update: 6/17/07
            
 installs the software in 3 steps. is self-invoking.
 must be removed immediately after installation as 
 it could be used to delete (somewhat) arbitrary tables
 from the db.
 
 This software is licensed under the GPL.
****************************************************/
echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n";
echo "<html>\n";
echo "<head>\n";
echo "	<title>Installation</title>\n";
echo "	<link rel='stylesheet' type='text/css' href = 'apply.css' />\n";
echo "	<meta http-equiv=\"content-type\" content=\"text/html; charset=iso-8859-1\" />\n";
echo "</head>\n";
echo "<body>\n";
echo "<div id='appBox'>\n";
include("const.php");
include("functions.php");
$dontLogin = 1;
$doDebug = 0;
if ($_GET['debug'] == 1)
{
	$doDebug = 1;
}
if ($doDebug) echo "Debugging..<br />\n";

function applyFixPath($path)
{
	if (substr($path,count($path)-2,1) != "/") $path .= "/";
	return $path;
}
/*************************** Grab Database Info Functions *********************************/
function applyGrabDB($forum, $path)
{
	//gets database connection info - calls forum-specific functions.
	if ($forum == "phpBB2") $applyDB = applyPhpBB2GrabDB($path);
	elseif ($forum == "phpBB3") $applyDB = applyPhpBB3GrabDB($path);
	elseif ($forum == "phpNuke") $applyDB = applyPhpNukeGrabDB($path);
	elseif ($forum == "punBB") $applyDB = applypunBBGrabDB($path);
	elseif ($forum == "SMF") $applyDB = applySMFGrabDB($path);
	else die("Invalid forum type: Please start over.");
	return $applyDB;
}

function applyPhpBB2GrabDB($path)
{
	//Opens the config file for phpBB2 and grabs the necessary information.
	$path = applyFixPath($path);
	$filename = $path."config.php";
	if (!file_exists($filename)) die("Can't locate forum config file. Check your directory location.");
	include($filename);
	return array("type" => $dbms, "host" => $dbhost, "name" => $dbname, "user" => $dbuser, "pass" => $dbpasswd, "forumPrefix" => $table_prefix);
}

function applyPhpBB3GrabDB($path)
{
	//Opens the config file for phpBB3 and grabs the necessary information.
	$path = applyFixPath($path);
	$filename = $path."config.php";
	if (!file_exists($filename)) die("Can't locate forum config file. Check your directory location.");
	include($filename);
	return array("type" => $dbms, "host" => $dbhost, "name" => $dbname, "user" => $dbuser, "pass" => $dbpasswd, "forumPrefix" => $table_prefix);
}

function applyPhpNukeGrabDB($path)
{
	//Opens the config file for phpNuke and grabs the necessary information.
	$path = applyFixPath($path);
	$filename = $path."config.php";
	if (!file_exists($filename)) die("Can't locate forum config file. Check your directory location.");
	include($filename);
	return array("type" => $dbtype, "host" => $dbhost, "name" => $dbname, "user" => $dbuname, "pass" => $dbpass, "forumPrefix" => $prefix);
}

function applyPunBBGrabDB($path)
{
	//Opens the config file for phpNuke and grabs the necessary information.
	$path = applyFixPath($path);
	$filename = $path."config.php";
	if (!file_exists($filename)) die("Can't locate forum config file. Check your directory location.");
	include($filename);
	return array("type" => $db_type, "host" => $db_host, "name" => $db_name, "user" => $db_username, "pass" => $db_password, "forumPrefix" => $db_prefix);
}

function applySMFGrabDB($path)
{
	//Opens the config file for SMF and grabs the necessary information.
	$path = applyFixPath($path);
	$filename = $path."Settings.php";
	if (!file_exists($filename)) die("Can't locate forum config file. Check your directory location.");
	include($filename);
	return array("type" => "", "host" => $db_server, "name" => $db_name, "user" => $db_user, "pass" => $db_passwd, "forumPrefix" => $db_prefix);
}

function applyMakeTables()
{
	//Creates the database tables needed for the rest of the system.
	global $applyPrefix;
	applyQuery("CREATE TABLE `".$applyPrefix."apps` (`appID` INT NOT NULL AUTO_INCREMENT ,`appUserName` VARCHAR( 32 ) NOT NULL ,`appUserEmail` VARCHAR( 64 ) NOT NULL ,`appName` VARCHAR( 32 ) NOT NULL ,`appCreated` INT NOT NULL ,`appUpdated` INT NOT NULL ,`appLevel` TINYINT NOT NULL ,`appClass` VARCHAR( 32 ) NOT NULL ,`appRace` VARCHAR( 32 ) NOT NULL ,`appNumComments` TINYINT NOT NULL ,`appLastComment` INT NOT NULL,`appStatus` TINYINT NOT NULL ,PRIMARY KEY ( `appID` ));");
	applyQuery("CREATE TABLE `".$applyPrefix."categories` (`catID` INT NOT NULL AUTO_INCREMENT ,`catName` VARCHAR( 32 ) NOT NULL ,`catDesc` VARCHAR( 255 ) NOT NULL ,`catOrder` TINYINT NOT NULL ,`catLoc` TINYINT NOT NULL ,PRIMARY KEY ( `catID` ));");
	applyQuery("CREATE TABLE `".$applyPrefix."comments` (`commID` INT NOT NULL AUTO_INCREMENT ,`commAppID` INT NOT NULL ,`commTime` INT NOT NULL ,`commMemberName` VARCHAR( 32 ) NOT NULL ,`commShare` VARCHAR( 3 ) NOT NULL ,`commData` BLOB NOT NULL ,PRIMARY KEY ( `commID` ))");
	applyQuery("CREATE TABLE `".$applyPrefix."config` (`configName` VARCHAR( 255 ) NOT NULL ,`configData` VARCHAR( 255 ) NOT NULL);");
	applyQuery("CREATE TABLE `".$applyPrefix."edits` (`editAppID` INT NOT NULL ,`editTime` INT NOT NULL ,`editDescription` BLOB NOT NULL)");
	applyQuery("CREATE TABLE `".$applyPrefix."fields` (`fieldID` INT NOT NULL AUTO_INCREMENT ,`fieldCat` TINYINT NOT NULL ,`fieldName` VARCHAR( 32 ) NOT NULL ,`fieldType` TINYINT NOT NULL ,`fieldDesc` VARCHAR( 255 ) NOT NULL ,`fieldDetails` VARCHAR( 255 ) NOT NULL ,`fieldOrder` TINYINT NOT NULL,`fieldRequired` TINYINT NOT NULL, PRIMARY KEY ( `fieldID` ))");
	applyQuery("CREATE TABLE `".$applyPrefix."sessions` (`sessionID` VARCHAR( 32 ) NOT NULL ,`sessionTime` INT NOT NULL ,`sessionPermissions` TINYINT NOT NULL)");
	applyQuery("CREATE TABLE `".$applyPrefix."words` (  `wordsID` int(11) NOT NULL auto_increment,  `wordsName` varchar(32) NOT NULL default '',  `wordsData` blob NOT NULL,  PRIMARY KEY  (`wordsID`))");
}


if (!isset($_GET['step']))
{
	//step 1 - just prints out a form - real simple
	echo "<div class='appSecHead'>Application Setup - Step 1 of 3</div>\n";
	echo "<div class='appSecBody'>\n";
	
	echo "<br />";
	echo "<div class='appMinHead'>Warning</div>\n";
	echo "<div class='appMinBody'>\n";
	echo "<b>Back up your database now.</b><br />\n";
	echo "This is BETA software with absolutely no warranty, implied or otherwise. The maker of this sofware will not be held liable for any damages incurred through its use.\n";
	echo "</div>\n";
	echo "<br />";
	
	echo "<div class='appMinHead'>License</div>\n";
	echo "<div class='appMinBody'>\n";
	echo "This software is licensed under the GPL (General Public License).<br />\n";
	echo "By installing this software, you agree to the terms of the license (available at <a href = 'http://www.gnu.org/copyleft/gpl.html'>http://www.gnu.org/copyleft/gpl.html</a>)\n";
	echo "Certain optional parts included (the scriptalicious javascript library) are licensed under the MIT license, included.<br />\n";
	echo "By proceeding with the installation, you are agreeing to these licenses.<br />\n";
	echo "</div>\n";
	echo "<br />";
	
	echo "<div class='appMinHead'>Required Information</div>\n";
	echo "<div class='appMinBody'>\n";
	echo "<form method='post' name='appForm' action='install.php?step=2' enctype='multipart/form-data'>\n";
	echo "Forum Type: <select name='forumType'>\n";
	for ($i = 0; $i < count($applyForumTypeList); $i++)
	{
		echo "<option value='".$applyForumTypeList[$i]."'>".$applyForumTypeList[$i]."</option>\n";
	}
	echo "</select>\n";
	echo "<br />\n";
	echo "Forum Path (from here): <input type='text' name='forumPath' size='64'>for phpNuke, the directory containing your config.php file (example: '../forum/')<br />\n";
	echo "Enter a prefix: <input type='text' name='prefix' value='Apply_' size='16'><br />\n";
	echo "<input type='submit' value='Proceed to Step 2' class='appBtn' onmouseover=\"this.className='appBtn appBtnHov'\" onmouseout=\"this.className='appBtn'\">\n";
	echo "</form>\n";
	echo "</div>\n";
	
	echo "</div>\n";
}
elseif($_GET['step']==2)
{
	echo "<div class='appSecHead'>Application Setup - Step 2 of 3</div>\n";
	echo "<div class='appSecBody'>\n";
	
	$applyDB = applyGrabDB($_POST['forumType'], $_POST['forumPath']);
	
	//Set some of the database connection variables for this step only so we can connect to db and get the list of forums.
	$applyDBType = $applyDB['type'];
	$applyDBHost = $applyDB['host'];
	$applyDBName = $applyDB['name'];
	$applyDBUser = $applyDB['user'];
	$applyDBPass = $applyDB['pass'];
	$applyDBForumPrefix = $applyDB['forumPrefix'];
	$applyForumType = $_POST['forumType'];
	$applyForumPath = applyFixPath($_POST['forumPath']);
	
	applyInit();//connects to the DB
	
	include("includes/".$applyForumType."_functions.php");
	$applyForumList = applyGrabForumList(); //grab forum list.
	
	if (count($applyForumList) == 0) die("Error! Unable to load list of forums.");
	
	//Look to see if the tables we want to create already exist. print out a warning if they do.
	$lookTables = array($_POST['prefix']."apps",$_POST['prefix']."categories",$_POST['prefix']."comments",$_POST['prefix']."config",$_POST['prefix']."edits",$_POST['prefix']."fields",$_POST['prefix']."words", $_POST['prefix']."sessions");
	$delTables = array();
	$getTables = applyQuery("show tables;");
	while ($appTab = applyRow($getTables))
	{
		if (in_array($appTab[0], $lookTables)) array_push($delTables, $appTab[0]);
	}
	
	if (count($delTables) > 0)
	{
		echo "<div class='appWarning'><b>Warning! The following tables will be DELETED and all the data within LOST if you proceed:</b><br />\n";
		echo "<ul>\n";
		for ($i = 0; $i < count($delTables); $i++)
		{
			echo "<li>".$delTables[$i]."</li>\n";
		}
		echo "</ul>\n";
		echo "This cannot be undone.<br /><br />Click the back button on your browser and change the prefix if you don't want to delete these tables.</div>\n";
	}
	
	
	//print out the form for step 2 - includes list of all boards on the forum for permission-setting.
	echo "<form method='post' name='appForm' action='install.php?step=3' enctype='multipart/form-data'>\n";
	echo "Select a forum: <select name='forumID'>\n";
	$applyForumKeys = array_keys($applyForumList);
	for ($i = 0; $i < count($applyForumKeys); $i++)
	{
		echo "<option value='".$applyForumKeys[$i]."'>".$applyForumList[$applyForumKeys[$i]]."</option>\n";
	}
	echo "</select><br />\n";
	echo "Members who have permissions to view this forum will be given access to view apps.<br />\n";
	echo "Members are are forum admins are automatically given admin access.<br />\n";
	echo "<br />\n";
	
	echo "Faction: <select name='faction'>\n";
	echo "	<option value='alliance'>Alliance</option>\n";
	echo "	<option value='horde'>Horde</option>\b";
	echo "<br />\n";
	echo "<input type='hidden' name='prefix' value='".$_POST['prefix']."'>\n";
	echo "<input type='hidden' name='forumPath' value='".$applyForumPath."'>\n";
	echo "<input type='hidden' name='forumType' value='".$_POST['forumType']."'>\n";
	echo "<br />\n";
	echo "<input type='submit' value='Proceed to Step 3' class='appBtn' onmouseover=\"this.className='appBtn appBtnHov'\" onmouseout=\"this.className='appBtn'\">\n";
	echo "</form>\n";
	echo "</div>\n";
}
elseif($_GET['step']==3)
{
	$applyDB = applyGrabDB($_POST['forumType'], $_POST['forumPath']);
	
	if ($_POST['faction'] == 'alliance') $myRaces = "Draenei|Dwarf|Gnome|Human|Night Elf";
	else $myRaces = "Blood Elf|Orc|Tauren|Troll|Undead";
	
	echo "<div class='appSecHead'>Application Setup - Step 3 of 3</div>\n";
	echo "<div class='appSecBody'>\n";
	$applyPrefix = $_POST['prefix'];
	applyMakeConfig($_POST['forumPath'], $_POST['forumType'], $_POST['prefix'], $_POST['forumID'], $applyDB, "-1"); //generate config file
	if (!file_exists("config.php")) die("Creation of config.php failed! umm... try again? maybe try chmoding the directory to give more permissions");
	include("config.php");
	applyInit();//connect to DB
	
	//delete the tables we're going to overwrite, if any exist.
	$lookTables = array($_POST['prefix']."apps",$_POST['prefix']."categories",$_POST['prefix']."comments",$_POST['prefix']."config",$_POST['prefix']."edits",$_POST['prefix']."fields",$_POST['prefix']."words", $_POST['prefix']."sessions");
	$delTables = array();
	$getTables = applyQuery("show tables;");
	while ($appTab = applyRow($getTables))
	{
		if (in_array($appTab[0], $lookTables)) array_push($delTables, $appTab[0]);
	}
	
	if (count($delTables) > 0)
	{
		for ($i = 0; $i < count($delTables); $i++)
		{
			applyQuery("DROP table `".$delTables[$i]."`");
		}
	}
	
	//meat and potatoes of the installation - makes the tables then populates them
	applyMakeTables();
	include("init.php"); 
	
	//turn on the module in phpNuke if that's what we're using
	if ($_POST['forumType'] == "phpNuke")
	{
		$theCount = applySingleQuery("SELECT count(*) FROM `".$applyDB['forumPrefix']."_modules` WHERE `title` = 'App';");
		
		if ($theCount == 0)  applyQuery("INSERT INTO `".$applyDB['forumPrefix']."_modules` ( `mid` , `title` , `custom_title` , `active` , `view` , `inmenu` , `mod_group` , `admins` ) VALUES ('', 'App', 'Apply', '1', '0', '1', '0', '');");
		else applyQuery("UPDATE `".$applyDB['forumPrefix']."_modules` SET `active` = '1', `custom_title` = 'Apply' WHERE `title` = 'App';");
		echo "<br />phpNuke Module corrected<br />\n";
	}
	
	
	echo "<br /><div class='appFeedback'><b>Your application center has been set up! Please delete install.php from the server.</b></div><br />";
	echo "<a href='index.php'>Proceed</a>";
	
	echo "</div>\n";
}
else
{
	echo "invalid step!";
}
echo "</div>\n</body>\n</html>\n";
?>