<?php
/***************************************************
                  viewApps.php
               Written By: Yume
              Last Update: 6/22/07

 Lets guild members see a list of all applicants. 
 Allows for sorting by all of the fields as well as
 narrowing down by class. Search feature calls searcher.php
 and uses ajax.
   
 This software is licensed under the GPL.
****************************************************/
$applyPageTitle="View Apps";
include("header.php");

if (!$applyUserdata['isMember']) applyNoAccess(); //must be a guild member to enter

function applyGetLink($field, $prev, $order, $filter, $page)//Generates a link for clicking on for sorting.
{	
	//Field  is the name of the field (appClass, appName, etc)
	//prev is the previous sort (so it can do reverse sort if it's the same field)
	//order is the previous order
	//filter just appends current filters to the url it's creating
	
	$out = "";
	$out .= "viewApps.php?sort=" . $field;
	$ord = "";
	if ($prev == $field)
	{
		if ($order == "ASC") $ordr = "DESC";
		else $ordr = "ASC";
	}
	else 
	{
		if ($field == 'appUpdated' || $field == 'appCreated' || $field == 'appLastComment') $ordr = "DESC";
		else $ordr = "ASC";
	}
	if ($filter) $out .= "&filter=" . $filter;
	$out .= "&order=" . $ordr;
	$out .= "&page=" . $page;
	return $out;
}

function applyPrintNameInfo($ID, $name)
{
	if ($name == "" || !$name || $name == " ") $name = "(blank)";
	echo "<a href = 'details.php?appID=".$ID."'>".$name."</a>";
}

function applyPrintLastCommentInfo($app)
{
	if ($app['appNumComments'] == 0) return;
	$time = $app['commTime'];
	if (time() - $time < 86400) echo "<b>";
	echo $app['commMemberName']."<br />".date("g:i a", $time)."<br />".date("m-d-Y", $time);
	if (time() - $time < 86400) echo "</b>";
}

function applyPrintTimeInfo($time)
{
	if (time() - $time < 86400) echo "<b>";
	echo date("g:i a", $time)."<br />".date("m-d-Y", $time);
	if (time() - $time < 86400) echo "</b>";
}

function applyPrintSpecInfo($piped)
{
	//prints out the apps spec. Takes a pipe delimited string

	$arr = applyUnPipe($piped);
	
	echo $arr[1].": ".$arr[0]."<br />\n";
	echo $arr[3].": ".$arr[2]."<br />\n";
	echo $arr[5].": ".$arr[4]."\n";
}

function applyPrintStatusInfo($status)
{
	//prints out the apps status.
	global $applyConfig;
	
	if ($applyConfig['showStatus'])
	{
		echo applyGetStatus($status);
	}
}

?>
<script type="text/javascript" src="lib/engine.js"></script>       
<script type="text/javascript">
function submit_form() {
	var querys = document.getElementById('querys').value;
	url = 'searcher.php?querys=' + escape(querys) + '&sessID=<?php echo $applyUserdata['session']; ?>';
	ajax_do(url, 'result');
}
</script>

<?php
if (isset($_GET['delete']) && $applyUserdata['isAdmin']) //allows for deletion 
{
	if(isset($_POST['verify']))
	{
		 if ($_POST['verify'] == "yes")
		 {
			applyDelApp($_GET['delete']);
		}
	}
	else applyVerifyDelApp($_GET['delete'], "viewApps.php");
}

echo "<div class = 'appSecHead'>" . applyTitle("View all Applications") . "</div>\n";
echo "<div class = 'appSecBody'>";

//grab all fields
$applyFields = applyGetAllFields(1);
//grab the config line and turn it into an array
$applyView = applyUnPipe($applyConfig['viewApps']);

$applySpec = -1;
//find the 'spec' field (if it exists)
for ($i = 0; $i <count($applyFields); $i++)
{
	if ($applyFields[$i]['fieldType'] == 6) $applySpec = $applyFields[$i]['fieldID'];
}

echo "<form method='get' action='" . applyGetLink($_GET['sort'], "", $_GET['order'], "", 0) . "'>";
echo "<p>Filter by Class: ";
echo "<select name='filter' class='input' onchange='javascript:form.submit();'>";
$applyClasses = applyUnPipe("none|".applyGetClasses());
for ($i = 0; $i < count($applyClasses); $i++)
{
	echo "	<option value='".$applyClasses[$i]."' ";
	if ($_GET['filter'] == $applyClasses[$i]) echo "selected ";
	echo "> ".$applyClasses[$i]."</option>\n";
}
echo "</select>";
echo "</form>";
echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Search: <input type='text' onkeyup='submit_form();' name='querys' id='querys'>\n";
echo "<div id='contentdiv' style = 'display: inline;'></div>";
echo "</p>\n";
$applySort = "";
$applyFilter = "";
$applyLimit = "LIMIT ";
if ($_GET['filter'] && $_GET['filter'] != "none") $applyFilter = " WHERE `appClass` = '" . $_GET['filter'] . "'";
if ($_GET['sort'])
{
	$applySort = $_GET['sort'];
	$applyOrder = $_GET['order'];
}
if (!$_GET['sort'])
{
	$applySort = "appUpdated";
	$applyOrder = "DESC";
}
if ( !$_GET['page'] ) $applyPage = 0;
else $applyPage .= $_GET['page'];

$applyLimit .= $applyPage*$applyConfig['numApps'] . ", " . $applyConfig['numApps'];

$findApps = "SELECT
 a.appUserName appUserName,
 a.appID appID,
 c.commMembername commMemberName,
 c.commTime commTime";
 
for ($pipe = 0; $pipe < count($applyView); $pipe++)
{
	$slashArr = explode("/", $applyView[$pipe]);
	for ($slash = 0; $slash < count($slashArr); $slash++)
	{
		$dashArr = explode("-", $slashArr[$slash]);
		for ($dash = 0; $dash < count($dashArr); $dash++)
		{
			$fld = $dashArr[$dash];
			if ($fld != "Icon")
			{
				$findApps .= ", a.app".$fld." app".$fld;
			}
		}
	}
}
 
 
$findApps .= sprintf(" FROM `".$applyPrefix."apps` a JOIN `".$applyPrefix."comments` c ON (c.commID = a.appLastComment)
 %s
 GROUP BY a.appID
 ORDER BY %s %s
	%s;", $applyFilter, $applySort, $applyOrder, $applyLimit);
	
//echo $findApps;

$getApps = applyQuery($findApps); // pull apps from the db. sorting and filtering is inserted into the sql query so no postprocessing is required.
if ($app = applyRow($getApps))//output apps.
{
	echo "<p>Click on an applicant's name to view the full details of their application and any comments posted about that app. Fields updated within 24 hours have their dates bolded.</p>\n";
	echo "<table border='0' cellpadding = '5' cellspacing = '0' width='100%'>";
	echo "<tr>\n";
	for ($pipe = 0; $pipe < count($applyView); $pipe++)
	{
		echo "<td class='appHead'>";
		$slashArr = explode("/", $applyView[$pipe]);
		for ($slash = 0; $slash < count($slashArr); $slash++)
		{
			$dashArr = explode("-", $slashArr[$slash]);
			for ($dash = 0; $dash < count($dashArr); $dash++)
			{
				$fld = $dashArr[$dash];
				$wholeField = applyFieldByID($applyFields,$fld);
				if ($dash > 0) echo " ";
				echo "<a href ='".applyGetLink("app".$fld, $_GET['sort'], $_GET['order'], $_GET['filter'], 0)."'><b>".$wholeField['fieldName']."</b></a>";
			}
			echo "<br />";
		}
		echo "</td>\n";
	}
	if ($applyUserdata['isAdmin']) echo "<td class='appHead'><b>X</b></td>";
	echo "</tr>\n";
	$i = 0;
	do
	{//these next few lines are for bolding recently updated fields.
		if ($i%2 == 0) $myColor = "row1";
		if ($i%2 == 1) $myColor = "row2";
		
		echo "<tr class = '" . $myColor . "'>\n";
		for ($pipe = 0; $pipe < count($applyView); $pipe++)
		{
			echo "<td>";
			$slashArr = explode("/", $applyView[$pipe]);
			for ($slash = 0; $slash < count($slashArr); $slash++)
			{
				if ($slash>0) echo "<br />";
				$dashArr = explode("-", $slashArr[$slash]);
				for ($dash = 0; $dash < count($dashArr); $dash++)
				{
					//it'd be nice to run each field against the list of fields and find the field type and send the data to a specific function to print out
					//but that'd be way too slow so we'll settle for some if statements.
					$fld = $dashArr[$dash];
					if ($dash > 0) echo " ";
					if ($fld == "Icon") applyPrintClassIcon($app['appClass']);
					elseif ($fld == "Name") applyPrintNameInfo($app['appID'], $app['appName']);
					elseif ($fld == "LastComment") applyPrintLastCommentInfo($app);
					elseif ($fld == "Status") applyPrintStatusInfo($app['appStatus']);
					elseif ($fld == "Created" || $fld == "Updated") applyPrintTimeInfo($app['app'.$fld]);
					elseif ($fld == $applySpec) applyPrintSpecInfo($app['app'.$fld]);
					else echo $app['app'.$fld];
				}
			}
			echo "</td>\n";
		}
		if ($applyUserdata['isAdmin']) echo "<td><a href = 'viewApps.php?delete=" . $app['appID'] . "'>x</a></td>";
		echo "</tr>\n";
		$i++;
	} while ($app = applyRow($getApps));
	echo "</table>";
	
	$applyQC = applySingleQuery("SELECT count(*) from `".$applyPrefix."apps` ".$applyFilter.";");
	
	$applyC = applySingleQuery("SELECT count(*) from `".$applyPrefix."apps`;");
	
	//pagination
	echo "<p style='width:100%; text-align: center;'>\n";
	if ($applyPage > 0)
	{
		$applyNewPage = $applyPage - 1;
		echo "<a href = '" . applyGetLink($applySort, 'n', $applyOrder, $_GET['filter'], $applyNewPage) . "'>&lt;</a> - ";
	}
	$numPages = $applyQC/$applyConfig['numApps'];
	for ($j = 0; $j < $numPages; $j++)
	{
		if ($j > 0) echo " - ";
		if ($j != $applyPage) echo "<a href = '" . applyGetLink($applySort, 'n', $applyOrder, $_GET['filter'], $j) . "'>".($j+1)." </a>";
		else echo ($j+1);
	}
	if ( ( (($applyPage+1) * $applyConfig['numApps']) < $applyQC && $applyQC%$applyConfig['numApps']>0 ) || ( ( $applyQC%$applyConfig['numApps']==0 ) && $applyQC/$applyConfig['numApps']>$applyPage+1) )
	{
		$applyNewPage = $applyPage + 1;
		echo " - <a href = '" . applyGetLink($applySort, 'n', $applyOrder, $_GET['filter'], $applyNewPage) . "'>&gt;</a> ";
	}
	echo "</p>";
	
	//quick stats
	echo "<p style='width:100%; text-align: center;'>\n";
	echo "<i>" . $i . " apps listed.</i> | ";
	echo "<i>" . $applyQC . " apps total in query.</i> | ";
	echo "<i>" . $applyC . " apps total.</i>\n";
	echo "</p>\n";
	
}
else echo "No apps at this time";
applyFree($getApps);

echo "</div>\n"; // end appSecHead
echo "<div class='appSecFoot'></div>\n";

include('footer.php');
?>